Cgl 0.60.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
Public Types | Friends | List of all members
ClpSimplex Class Reference

This solves LPs using the simplex method. More...

`#include <ClpSimplex.hpp>`

Inheritance diagram for ClpSimplex:
[legend]
Collaboration diagram for ClpSimplex:
[legend]

## Public Types
enum | Status { isFree = 0x00, basic = 0x01, atUpperBound = 0x02, atLowerBound = 0x03, superBasic = 0x04, isFixed = 0x05 }
| enums for status of various sorts. More...
enum | FakeBound { noFake = 0x00, lowerFake = 0x01, upperFake = 0x02, bothFake = 0x03 }

## Public Member Functions
Constructors and destructor and copy
| ClpSimplex (bool emptyMessages=false)
| Default constructor. More...
| ClpSimplex (const ClpSimplex &rhs, int scalingMode=-1)
| Copy constructor. More...
| ClpSimplex (const ClpModel &rhs, int scalingMode=-1)
| Copy constructor from model. More...
| ClpSimplex (const ClpModel *wholeModel, int numberRows, const int *whichRows, int numberColumns, const int *whichColumns, bool dropNames=true, bool dropIntegers=true, bool fixOthers=false)
| Subproblem constructor. More...
| ClpSimplex (const ClpSimplex *wholeModel, int numberRows, const int *whichRows, int numberColumns, const int *whichColumns, bool dropNames=true, bool dropIntegers=true, bool fixOthers=false)
| Subproblem constructor. More...
| ClpSimplex (ClpSimplex *wholeModel, int numberColumns, const int *whichColumns)
| This constructor modifies original ClpSimplex and stores original stuff in created ClpSimplex. More...
void | originalModel (ClpSimplex *miniModel)
| This copies back stuff from miniModel and then deletes miniModel. More...
void | setPersistenceFlag (int value)
| Array persistence flag If 0 then as now (delete/new) 1 then only do arrays if bigger needed 2 as 1 but give a bit extra if bigger needed. More...
void | makeBaseModel ()
| Save a copy of model with certain state - normally without cuts. More...
void | deleteBaseModel ()
| Switch off base model. More...
ClpSimplex * | baseModel () const
| See if we have base model. More...
void | setToBaseModel (ClpSimplex *model=NULL)
| Reset to base model (just size and arrays needed) If model NULL use internal copy. More...
ClpSimplex & | operator= (const ClpSimplex &rhs)
| Assignment operator. This copies the data. More...
| ~ClpSimplex ()
| Destructor. More...
void | loadProblem (const ClpMatrixBase &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub, const double *rowObjective=NULL)
| Loads a problem (the constraints on the rows are given by lower and upper bounds). More...
void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub, const double *rowObjective=NULL)
void | loadProblem (const int numcols, const int numrows, const CoinBigIndex *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub, const double *rowObjective=NULL)
| Just like the other loadProblem() method except that the matrix is given in a standard column major ordered format (without gaps). More...
void | loadProblem (const int numcols, const int numrows, const CoinBigIndex *start, const int *index, const double *value, const int *length, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub, const double *rowObjective=NULL)
| This one is for after presolve to save memory. More...
int | loadProblem (CoinModel &modelObject, bool keepSolution=false)
| This loads a model from a coinModel object - returns number of errors. More...
int | readMps (const char *filename, bool keepNames=false, bool ignoreErrors=false)
| Read an mps file from the given filename. More...
int | readGMPL (const char *filename, const char *dataName, bool keepNames=false)
| Read GMPL files from the given filenames. More...
int | readLp (const char *filename, const double epsilon=1e-5)
| Read file in LP format from file with name filename. More...
void | writeLp (const char *filename, const char *extension="lp", double epsilon=1e-5, int numberAcross=10, int decimals=5, double objSense=0.0, bool useRowNames=true) const
| Write the problem into an Lp file of the given filename. More...
void | borrowModel (ClpModel &otherModel)
| Borrow model. More...
void | borrowModel (ClpSimplex &otherModel)
void | passInEventHandler (const ClpEventHandler *eventHandler)
| Pass in Event handler (cloned and deleted at end) More...
void | getbackSolution (const ClpSimplex &smallModel, const int *whichRow, const int *whichColumn)
| Puts solution back into small model. More...
int | loadNonLinear (void *info, int &numberConstraints, ClpConstraint **&constraints)
| Load nonlinear part of problem from AMPL info Returns 0 if linear 1 if quadratic objective 2 if quadratic constraints 3 if nonlinear objective 4 if nonlinear constraints -1 on failure. More...
Functions most useful to user
int | initialSolve (ClpSolve &options)
| General solve algorithm which can do presolve. More...
int | initialSolve ()
| Default initial solve. More...
int | initialDualSolve ()
| Dual initial solve. More...
int | initialPrimalSolve ()
| Primal initial solve. More...
int | initialBarrierSolve ()
| Barrier initial solve. More...
int | initialBarrierNoCrossSolve ()
| Barrier initial solve, not to be followed by crossover. More...
int | dual (int ifValuesPass=0, int startFinishOptions=0)
| Dual algorithm - see ClpSimplexDual.hpp for method. More...
int | dualDebug (int ifValuesPass=0, int startFinishOptions=0)
int | primal (int ifValuesPass=0, int startFinishOptions=0)
| Primal algorithm - see ClpSimplexPrimal.hpp for method. More...
int | nonlinearSLP (int numberPasses, double deltaTolerance)
| Solves nonlinear problem using SLP - may be used as crash for other algorithms when number of iterations small. More...
int | nonlinearSLP (int numberConstraints, ClpConstraint **constraints, int numberPasses, double deltaTolerance)
| Solves problem with nonlinear constraints using SLP - may be used as crash for other algorithms when number of iterations small. More...
int | barrier (bool crossover=true)
| Solves using barrier (assumes you have good cholesky factor code). More...
int | reducedGradient (int phase=0)
| Solves non-linear using reduced gradient. More...
int | solve (CoinStructuredModel *model)
| Solve using structure of model and maybe in parallel. More...
int | loadProblem (CoinStructuredModel &modelObject, bool originalOrder=true, bool keepSolution=false)
| This loads a model from a CoinStructuredModel object - returns number of errors. More...
int | cleanup (int cleanupScaling)
| When scaling is on it is possible that the scaled problem is feasible but the unscaled is not. More...
int | cleanPrimalSolution (double exactMultiple)
| Clean primal solution If you expect solution to only have exact multiples of "exactMultiple" then this tries moving solution values to nearest multiple. More...
int | dualRanging (int numberCheck, const int *which, double *costIncrease, int *sequenceIncrease, double *costDecrease, int *sequenceDecrease, double *valueIncrease=NULL, double *valueDecrease=NULL)
| Dual ranging. More...
int | primalRanging (int numberCheck, const int *which, double *valueIncrease, int *sequenceIncrease, double *valueDecrease, int *sequenceDecrease)
| Primal ranging. More...
int | modifyCoefficientsAndPivot (int number, const int *which, const CoinBigIndex *start, const int *row, const double *newCoefficient, const unsigned char *newStatus=NULL, const double *newLower=NULL, const double *newUpper=NULL, const double *newObjective=NULL)
| Modifies coefficients etc and if necessary pivots in and out. More...
int | outDuplicateRows (int numberLook, int *whichRows, bool noOverlaps=false, double tolerance=-1.0, double cleanUp=0.0)
| Take out duplicate rows (includes scaled rows and intersections). More...
double | moveTowardsPrimalFeasible ()
| Try simple crash like techniques to get closer to primal feasibility returns final sum of infeasibilities. More...
void | removeSuperBasicSlacks (int threshold=0)
| Try simple crash like techniques to remove super basic slacks but only if > threshold. More...
ClpSimplex * | miniPresolve (char *rowType, char *columnType, void **info)
| Mini presolve (faster) Char arrays must be numberRows and numberColumns long on entry second part must be filled in as follows - 0 - possible >0 - take out and do something (depending on value - TBD) -1 row/column can't vanish but can have entries removed/changed -2 don't touch at all on exit <=0 ones will be in presolved problem struct will be created and will be long enough (information on length etc in first entry) user must delete struct. More...
void | miniPostsolve (const ClpSimplex *presolvedModel, void *info)
| After mini presolve. More...
void | miniSolve (char *rowType, char *columnType, int algorithm, int startUp)
| mini presolve and solve More...
int | writeBasis (const char *filename, bool writeValues=false, int formatType=0) const
| Write the basis in MPS format to the specified file. More...
int | readBasis (const char *filename)
| Read a basis from the given filename, returns -1 on file error, 0 if no values, 1 if values. More...
CoinWarmStartBasis * | getBasis () const
| Returns a basis (to be deleted by user) More...
void | setFactorization (ClpFactorization &factorization)
| Passes in factorization. More...
ClpFactorization * | swapFactorization (ClpFactorization *factorization)
void | copyFactorization (ClpFactorization &factorization)
| Copies in factorization to existing one. More...
int | tightenPrimalBounds (double factor=0.0, int doTight=0, bool tightIntegers=false)
| Tightens primal bounds to make dual faster. More...
int | crash (double gap, int pivot)
| Crash - at present just aimed at dual, returns -2 if dual preferred and crash basis created -1 if dual preferred and all slack basis preferred 0 if basis going in was not all slack 1 if primal preferred and all slack basis preferred 2 if primal preferred and crash basis created. More...
void | setDualRowPivotAlgorithm (ClpDualRowPivot &choice)
| Sets row pivot choice algorithm in dual. More...
void | setPrimalColumnPivotAlgorithm (ClpPrimalColumnPivot &choice)
| Sets column pivot choice algorithm in primal. More...
void | markHotStart (void *&saveStuff)
| Create a hotstart point of the optimization process. More...
void | solveFromHotStart (void *saveStuff)
| Optimize starting from the hotstart. More...
void | unmarkHotStart (void *saveStuff)
| Delete the snapshot. More...
int | strongBranching (int numberVariables, const int *variables, double *newLower, double *newUpper, double **outputSolution, int *outputStatus, int *outputIterations, bool stopOnFirstInfeasible=true, bool alwaysFinish=false, int startFinishOptions=0)
| For strong branching. More...
int | fathom (void *stuff)
| Fathom - 1 if solution. More...
int | fathomMany (void *stuff)
| Do up to N deep - returns -1 - no solution nNodes_ valid nodes >= if solution and that node gives solution ClpNode array is 2**N long. More...
double | doubleCheck ()
| Double checks OK. More...
int | startFastDual2 (ClpNodeStuff *stuff)
| Starts Fast dual2. More...
int | fastDual2 (ClpNodeStuff *stuff)
| Like Fast dual. More...
void | stopFastDual2 (ClpNodeStuff *stuff)
| Stops Fast dual2. More...
ClpSimplex * | fastCrunch (ClpNodeStuff *stuff, int mode)
| Deals with crunch aspects mode 0 - in 1 - out with solution 2 - out without solution returns small model or NULL. More...
Needed for functionality of OsiSimplexInterface
int | pivot ()
| Pivot in a variable and out a variable. More...
int | primalPivotResult ()
| Pivot in a variable and choose an outgoing one. More...
int | dualPivotResultPart1 ()
| Pivot out a variable and choose an incoing one. More...
int | pivotResultPart2 (int algorithm, int state)
| Do actual pivot state is 0 if need tableau column, 1 if in rowArray_[1]. More...
int | startup (int ifValuesPass, int startFinishOptions=0)
| Common bits of coding for dual and primal. More...
void | finish (int startFinishOptions=0)
bool | statusOfProblem (bool initial=false)
| Factorizes and returns true if optimal. More...
void | defaultFactorizationFrequency ()
| If user left factorization frequency then compute. More...
void | copyEnabledStuff (const ClpSimplex *rhs)
| Copy across enabled stuff from one solver to another. More...
most useful gets and sets
bool | primalFeasible () const
| If problem is primal feasible. More...
bool | dualFeasible () const
| If problem is dual feasible. More...
ClpFactorization * | factorization () const
| factorization More...
bool | sparseFactorization () const
| Sparsity on or off. More...
void | setSparseFactorization (bool value)
int | factorizationFrequency () const
| Factorization frequency. More...
void | setFactorizationFrequency (int value)
double | dualBound () const
| Dual bound. More...
void | setDualBound (double value)
double | infeasibilityCost () const
| Infeasibility cost. More...
void | setInfeasibilityCost (double value)
int | perturbation () const
| Amount of print out: 0 - none 1 - just final 2 - just factorizations 3 - as 2 plus a bit more 4 - verbose above that 8,16,32 etc just for selective debug. More...
void | setPerturbation (int value)
int | algorithm () const
| Current (or last) algorithm. More...
void | setAlgorithm (int value)
| Set algorithm. More...
bool | isObjectiveLimitTestValid () const
| Return true if the objective limit test can be relied upon. More...
double | sumDualInfeasibilities () const
| Sum of dual infeasibilities. More...
void | setSumDualInfeasibilities (double value)
double | sumOfRelaxedDualInfeasibilities () const
| Sum of relaxed dual infeasibilities. More...
void | setSumOfRelaxedDualInfeasibilities (double value)
int | numberDualInfeasibilities () const
| Number of dual infeasibilities. More...
void | setNumberDualInfeasibilities (int value)
int | numberDualInfeasibilitiesWithoutFree () const
| Number of dual infeasibilities (without free) More...
double | sumPrimalInfeasibilities () const
| Sum of primal infeasibilities. More...
void | setSumPrimalInfeasibilities (double value)
double | sumOfRelaxedPrimalInfeasibilities () const
| Sum of relaxed primal infeasibilities. More...
void | setSumOfRelaxedPrimalInfeasibilities (double value)
int | numberPrimalInfeasibilities () const
| Number of primal infeasibilities. More...
void | setNumberPrimalInfeasibilities (int value)
int | saveModel (const char *fileName)
| Save model to file, returns 0 if success. More...
int | restoreModel (const char *fileName)
| Restore model from file, returns 0 if success, deletes current model. More...
void | checkSolution (int setToBounds=0)
| Just check solution (for external use) - sets sum of infeasibilities etc. More...
void | checkSolutionInternal ()
| Just check solution (for internal use) - sets sum of infeasibilities etc. More...
void | checkUnscaledSolution ()
| Check unscaled primal solution but allow for rounding error. More...
CoinIndexedVector * | rowArray (int index) const
| Useful row length arrays (0,1,2,3,4,5) More...
CoinIndexedVector * | columnArray (int index) const
| Useful column length arrays (0,1,2,3,4,5) More...
double | alphaAccuracy () const
| Initial value for alpha accuracy calculation (-1.0 off) More...
void | setAlphaAccuracy (double value)
void | setDisasterHandler (ClpDisasterHandler *handler)
| Objective value. More...
ClpDisasterHandler * | disasterHandler () const
| Get disaster handler. More...
double | largeValue () const
| Large bound value (for complementarity etc) More...
void | setLargeValue (double value)
double | largestPrimalError () const
| Largest error on Ax-b. More...
double | largestDualError () const
| Largest error on basic duals. More...
void | setLargestPrimalError (double value)
| Largest error on Ax-b. More...
void | setLargestDualError (double value)
| Largest error on basic duals. More...
double | zeroTolerance () const
| Get zero tolerance. More...
void | setZeroTolerance (double value)
| Set zero tolerance. More...
int * | pivotVariable () const
| Basic variables pivoting on which rows. More...
bool | automaticScaling () const
| If automatic scaling on. More...
void | setAutomaticScaling (bool onOff)
double | currentDualTolerance () const
| Current dual tolerance. More...
void | setCurrentDualTolerance (double value)
double | currentPrimalTolerance () const
| Current primal tolerance. More...
void | setCurrentPrimalTolerance (double value)
int | numberRefinements () const
| How many iterative refinements to do. More...
void | setNumberRefinements (int value)
double | alpha () const
| Alpha (pivot element) for use by classes e.g. steepestedge. More...
void | setAlpha (double value)
double | dualIn () const
| Reduced cost of last incoming for use by classes e.g. steepestedge. More...
void | setDualIn (double value)
| Set reduced cost of last incoming to force error. More...
int | pivotRow () const
| Pivot Row for use by classes e.g. steepestedge. More...
void | setPivotRow (int value)
double | valueIncomingDual () const
| value of incoming variable (in Dual) More...
public methods
double * | solutionRegion (int section) const
| Return row or column sections - not as much needed as it once was. More...
double * | djRegion (int section) const
double * | lowerRegion (int section) const
double * | upperRegion (int section) const
double * | costRegion (int section) const
double * | solutionRegion () const
| Return region as single array. More...
double * | djRegion () const
double * | lowerRegion () const
double * | upperRegion () const
double * | costRegion () const
Status | getStatus (int sequence) const
void | setStatus (int sequence, Status newstatus)
bool | startPermanentArrays ()
| Start or reset using maximumRows_ and Columns_ - true if change. More...
void | setInitialDenseFactorization (bool onOff)
| Normally the first factorization does sparse coding because the factorization could be singular. More...
bool | initialDenseFactorization () const
int | sequenceIn () const
| Return sequence In or Out. More...
int | sequenceOut () const
void | setSequenceIn (int sequence)
| Set sequenceIn or Out. More...
void | setSequenceOut (int sequence)
int | directionIn () const
| Return direction In or Out. More...
int | directionOut () const
void | setDirectionIn (int direction)
| Set directionIn or Out. More...
void | setDirectionOut (int direction)
double | valueOut () const
| Value of Out variable. More...
double | lowerOut () const
| Lower of out variable. More...
double | upperOut () const
| Upper of out variable. More...
void | setValueOut (double value)
| Set value of out variable. More...
double | dualOut () const
| Dual value of Out variable. More...
void | setDualOut (double value)
| Set dual value of out variable. More...
void | setLowerOut (double value)
| Set lower of out variable. More...
void | setUpperOut (double value)
| Set upper of out variable. More...
void | setTheta (double value)
| Set theta of out variable. More...
int | isColumn (int sequence) const
| Returns 1 if sequence indicates column. More...
int | sequenceWithin (int sequence) const
| Returns sequence number within section. More...
double | solution (int sequence)
| Return row or column values. More...
double & | solutionAddress (int sequence)
| Return address of row or column values. More...
double | reducedCost (int sequence)
double & | reducedCostAddress (int sequence)
double | lower (int sequence)
double & | lowerAddress (int sequence)
| Return address of row or column lower bound. More...
double | upper (int sequence)
double & | upperAddress (int sequence)
| Return address of row or column upper bound. More...
double | cost (int sequence)
double & | costAddress (int sequence)
| Return address of row or column cost. More...
double | originalLower (int iSequence) const
| Return original lower bound. More...
double | originalUpper (int iSequence) const
| Return original lower bound. More...
double | theta () const
| Theta (pivot change) More...
double | lowerIn () const
| Lower Bound on In variable. More...
double | valueIn () const
| Value of In variable. More...
double | upperIn () const
| Upper Bound on In variable. More...
double | bestPossibleImprovement () const
| Best possible improvement using djs (primal) or obj change by flipping bounds to make dual feasible (dual) More...
ClpNonLinearCost * | nonLinearCost () const
| Return pointer to details of costs. More...
void | setNonLinearCost (ClpNonLinearCost &nonLinearCost)
| Set pointer to details of costs. More...
int | moreSpecialOptions () const
| Return more special options 1 bit - if presolve says infeasible in ClpSolve return 2 bit - if presolved problem infeasible return 4 bit - keep arrays like upper_ around 8 bit - no free or superBasic variables 16 bit - if checking replaceColumn accuracy before updating 32 bit - say optimal if primal feasible! 64 bit - give up easily in dual (and say infeasible) 128 bit - no objective, 0-1 and in B&B 256 bit - in primal from dual or vice versa 512 bit - alternative use of solveType_ 1024 bit - don't do row copy of factorization 2048 bit - perturb in complete fathoming 4096 bit - try more for complete fathoming 8192 bit - don't even think of using primal if user asks for dual (and vv) 16384 bit - in initialSolve so be more flexible 32768 bit - don't swap algorithms from dual if small infeasibility 65536 bit - perturb in postsolve cleanup (even if < 10000 rows) 131072 bit (*3) initial stateDualColumn 524288 bit - stop when primal feasible 1048576 bit - stop when primal feasible after n-1000000 iterations 2097152 bit - no primal in fastDual2 if feasible 4194304 bit - tolerances have been changed by code 8388608 bit - tolerances are dynamic (at first) 16777216 bit - if factorization kept can still declare optimal at once. More...
int | vectorMode () const
| Get vector mode. More...
void | setMoreSpecialOptions (int value)
| Set more special options 1 bit - if presolve says infeasible in ClpSolve return 2 bit - if presolved problem infeasible return 4 bit - keep arrays like upper_ around 8 bit - no free or superBasic variables 16 bit - if checking replaceColumn accuracy before updating 32 bit - say optimal if primal feasible! 64 bit - give up easily in dual (and say infeasible) 128 bit - no objective, 0-1 and in B&B 256 bit - in primal from dual or vice versa 512 bit - alternative use of solveType_ 1024 bit - don't do row copy of factorization 2048 bit - perturb in complete fathoming 4096 bit - try more for complete fathoming 8192 bit - don't even think of using primal if user asks for dual (and vv) 16384 bit - in initialSolve so be more flexible 32768 bit - don't swap algorithms from dual if small infeasibility 65536 bit - perturb in postsolve cleanup (even if < 10000 rows) 131072 bit (*3) initial stateDualColumn 524288 bit - stop when primal feasible 1048576 bit - don't perturb even if long time 2097152 bit - no primal in fastDual2 if feasible 4194304 bit - tolerances have been changed by code 8388608 bit - tolerances are dynamic (at first) 16777216 bit - if factorization kept can still declare optimal at once. More...
void | setVectorMode (int value)
| Set vector mode. More...
status methods
void | setFakeBound (int sequence, FakeBound fakeBound)
FakeBound | getFakeBound (int sequence) const
void | setRowStatus (int sequence, Status newstatus)
Status | getRowStatus (int sequence) const
void | setColumnStatus (int sequence, Status newstatus)
Status | getColumnStatus (int sequence) const
void | setPivoted (int sequence)
void | clearPivoted (int sequence)
bool | pivoted (int sequence) const
void | setFlagged (int sequence)
| To flag a variable (not inline to allow for column generation) More...
void | clearFlagged (int sequence)
bool | flagged (int sequence) const
void | setActive (int iRow)
| To say row active in primal pivot row choice. More...
void | clearActive (int iRow)
bool | active (int iRow) const
void | setPerturbed (int iSequence)
| To say perturbed. More...
void | clearPerturbed (int iSequence)
bool | perturbed (int iSequence) const
void | createStatus ()
| Set up status array (can be used by OsiClp). More...
void | allSlackBasis (bool resetSolution=false)
| Sets up all slack basis and resets solution to as it was after initial load or readMps. More...
int | lastBadIteration () const
| So we know when to be cautious. More...
void | setLastBadIteration (int value)
| Set so we know when to be cautious. More...
int | progressFlag () const
| Progress flag - at present 0 bit says artificials out. More...
ClpSimplexProgress * | progress ()
| For dealing with all issues of cycling etc. More...
int | forceFactorization () const
| Force re-factorization early value. More...
void | forceFactorization (int value)
| Force re-factorization early. More...
double | rawObjectiveValue () const
| Raw objective value (so always minimize in primal) More...
void | computeObjectiveValue (bool useWorkingSolution=false)
| Compute objective value from solution and put in objectiveValue_. More...
double | computeInternalObjectiveValue ()
| Compute minimization objective value from internal solution without perturbation. More...
double * | infeasibilityRay (bool fullRay=false) const
| Infeasibility/unbounded ray (NULL returned if none/wrong) Up to user to use delete [] on these arrays. More...
int | numberExtraRows () const
| Number of extra rows. More...
int | maximumBasic () const
| Maximum number of basic variables - can be more than number of rows if GUB. More...
int | baseIteration () const
| Iteration when we entered dual or primal. More...
void | generateCpp (FILE *fp, bool defaultFactor=false)
| Create C++ lines to get to current state. More...
ClpFactorization * | getEmptyFactorization ()
| Gets clean and emptyish factorization. More...
void | setEmptyFactorization ()
| May delete or may make clean and emptyish factorization. More...
void | moveInfo (const ClpSimplex &rhs, bool justStatus=false)
| Move status and solution across. More...
Basis handling
void | getBInvARow (int row, double *z, double *slack=NULL)
| Get a row of the tableau (slack part in slack if not NULL) More...
void | getBInvRow (int row, double *z)
| Get a row of the basis inverse. More...
void | getBInvACol (int col, double *vec)
| Get a column of the tableau. More...
void | getBInvCol (int col, double *vec)
| Get a column of the basis inverse. More...
void | getBasics (int *index)
| Get basic indices (order of indices corresponds to the order of elements in a vector retured by getBInvACol() and getBInvCol()). More...
Changing bounds on variables and constraints
void | setObjectiveCoefficient (int elementIndex, double elementValue)
| Set an objective function coefficient. More...
void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient. More...
void | setColumnLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -DBL_MAX for -infinity. More...
void | setColumnUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use DBL_MAX for infinity. More...
void | setColumnBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound. More...
void | setColumnSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously The default implementation just invokes setColLower() and setColUpper() over and over again. More...
void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -DBL_MAX for -infinity. More...
void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use DBL_MAX for infinity. More...
void | setColBounds (int elementIndex, double newlower, double newupper)
| Set a single column lower and upper bound. More...
void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously More...
void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -DBL_MAX for -infinity. More...
void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use DBL_MAX for infinity. More...
void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound. More...
void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of rows simultaneously More...
void | resize (int newNumberRows, int newNumberColumns)
| Resizes rim part of model. More...
Public Member Functions inherited from ClpModel
const double * | rowScale () const
| Scaling. More...
const double * | columnScale () const
const double * | inverseRowScale () const
const double * | inverseColumnScale () const
double * | mutableRowScale () const
double * | mutableColumnScale () const
double * | mutableInverseRowScale () const
double * | mutableInverseColumnScale () const
double * | swapRowScale (double *newScale)
void | setRowScale (double *scale)
void | setColumnScale (double *scale)
double | objectiveScale () const
| Scaling of objective. More...
void | setObjectiveScale (double value)
double | rhsScale () const
| Scaling of rhs and bounds. More...
void | setRhsScale (double value)
void | scaling (int mode=1)
| Sets or unsets scaling, 0 -off, 1 equilibrium, 2 geometric, 3 auto, 4 auto-but-as-initialSolve-in-bab. More...
void | unscale ()
| If we constructed a "really" scaled model then this reverses the operation. More...
int | scalingFlag () const
| Gets scalingFlag. More...
double * | objective () const
| Objective. More...
double * | objective (const double *solution, double &offset, bool refresh=true) const
const double * | getObjCoefficients () const
double * | rowObjective () const
| Row Objective. More...
const double * | getRowObjCoefficients () const
double * | columnLower () const
| Column Lower. More...
const double * | getColLower () const
double * | columnUpper () const
| Column Upper. More...
const double * | getColUpper () const
CoinPackedMatrix * | matrix () const
| Matrix (if not ClpPackedmatrix be careful about memory leak. More...
CoinBigIndex | getNumElements () const
| Number of elements in matrix. More...
double | getSmallElementValue () const
| Small element value - elements less than this set to zero, default is 1.0e-20. More...
void | setSmallElementValue (double value)
ClpMatrixBase * | rowCopy () const
| Row Matrix. More...
void | setNewRowCopy (ClpMatrixBase *newCopy)
| Set new row matrix. More...
ClpMatrixBase * | clpMatrix () const
| Clp Matrix. More...
ClpPackedMatrix * | clpScaledMatrix () const
| Scaled ClpPackedMatrix. More...
void | setClpScaledMatrix (ClpPackedMatrix *scaledMatrix)
| Sets pointer to scaled ClpPackedMatrix. More...
ClpPackedMatrix * | swapScaledMatrix (ClpPackedMatrix *scaledMatrix)
| Swaps pointer to scaled ClpPackedMatrix. More...
void | replaceMatrix (ClpMatrixBase *matrix, bool deleteCurrent=false)
| Replace Clp Matrix (current is not deleted unless told to and new is used) So up to user to delete current. More...
void | replaceMatrix (CoinPackedMatrix *newmatrix, bool deleteCurrent=false)
| Replace Clp Matrix (current is not deleted unless told to and new is used) So up to user to delete current. More...
double | objectiveValue () const
| Objective value. More...
void | setObjectiveValue (double value)
double | getObjValue () const
char * | integerInformation () const
| Integer information. More...
double * | infeasibilityRay (bool fullRay=false) const
| Infeasibility/unbounded ray (NULL returned if none/wrong) Up to user to use delete [] on these arrays. More...
double * | unboundedRay () const
double * | ray () const
| For advanced users - no need to delete - sign not changed. More...
bool | rayExists () const
| just test if infeasibility or unbounded Ray exists More...
void | deleteRay ()
| just delete ray if exists More...
const double * | internalRay () const
| Access internal ray storage. Users should call infeasibilityRay() or unboundedRay() instead. More...
bool | statusExists () const
| See if status (i.e. basis) array exists (partly for OsiClp) More...
unsigned char * | statusArray () const
| Return address of status (i.e. basis) array (char[numberRows+numberColumns]) More...
unsigned char * | statusCopy () const
| Return copy of status (i.e. More...
void | copyinStatus (const unsigned char *statusArray)
| Copy in status (basis) vector. More...
void | setUserPointer (void *pointer)
| User pointer for whatever reason. More...
void * | getUserPointer () const
void | setTrustedUserPointer (ClpTrustedData *pointer)
| Trusted user pointer. More...
ClpTrustedData * | getTrustedUserPointer () const
int | whatsChanged () const
| What has changed in model (only for masochistic users) More...
void | setWhatsChanged (int value)
int | numberThreads () const
| Number of threads (not really being used) More...
void | setNumberThreads (int value)
| ClpModel (bool emptyMessages=false)
| Default constructor. More...
| ClpModel (const ClpModel &rhs, int scalingMode=-1)
| Copy constructor. More...
ClpModel & | operator= (const ClpModel &rhs)
| Assignment operator. This copies the data. More...
| ClpModel (const ClpModel *wholeModel, int numberRows, const int *whichRows, int numberColumns, const int *whichColumns, bool dropNames=true, bool dropIntegers=true)
| Subproblem constructor. More...
| ~ClpModel ()
| Destructor. More...
void | loadProblem (const ClpMatrixBase &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub, const double *rowObjective=NULL)
| Loads a problem (the constraints on the rows are given by lower and upper bounds). More...
void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub, const double *rowObjective=NULL)
void | loadProblem (const int numcols, const int numrows, const CoinBigIndex *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub, const double *rowObjective=NULL)
| Just like the other loadProblem() method except that the matrix is given in a standard column major ordered format (without gaps). More...
int | loadProblem (CoinModel &modelObject, bool tryPlusMinusOne=false)
| This loads a model from a coinModel object - returns number of errors. More...
void | loadProblem (const int numcols, const int numrows, const CoinBigIndex *start, const int *index, const double *value, const int *length, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub, const double *rowObjective=NULL)
| This one is for after presolve to save memory. More...
void | loadQuadraticObjective (const int numberColumns, const CoinBigIndex *start, const int *column, const double *element)
| Load up quadratic objective. More...
void | loadQuadraticObjective (const CoinPackedMatrix &matrix)
void | deleteQuadraticObjective ()
| Get rid of quadratic objective. More...
void | setRowObjective (const double *rowObjective)
| This just loads up a row objective. More...
int | readMps (const char *filename, bool keepNames=false, bool ignoreErrors=false)
| Read an mps file from the given filename. More...
int | readGMPL (const char *filename, const char *dataName, bool keepNames=false)
| Read GMPL files from the given filenames. More...
void | copyInIntegerInformation (const char *information)
| Copy in integer informations. More...
void | deleteIntegerInformation ()
| Drop integer informations. More...
void | setContinuous (int index)
| Set the index-th variable to be a continuous variable. More...
void | setInteger (int index)
| Set the index-th variable to be an integer variable. More...
bool | isInteger (int index) const
| Return true if the index-th variable is an integer variable. More...
void | resize (int newNumberRows, int newNumberColumns)
| Resizes rim part of model. More...
void | deleteRows (int number, const int *which)
| Deletes rows. More...
void | addRow (int numberInRow, const int *columns, const double *elements, double rowLower=-COIN_DBL_MAX, double rowUpper=COIN_DBL_MAX)
| Add one row. More...
void | addRows (int number, const double *rowLower, const double *rowUpper, const CoinBigIndex *rowStarts, const int *columns, const double *elements)
| Add rows. More...
void | addRows (int number, const double *rowLower, const double *rowUpper, const CoinBigIndex *rowStarts, const int *rowLengths, const int *columns, const double *elements)
| Add rows. More...
void | addRows (int number, const double *rowLower, const double *rowUpper, const CoinPackedVectorBase *const *rows)
int | addRows (const CoinBuild &buildObject, bool tryPlusMinusOne=false, bool checkDuplicates=true)
| Add rows from a build object. More...
int | addRows (CoinModel &modelObject, bool tryPlusMinusOne=false, bool checkDuplicates=true)
| Add rows from a model object. More...
void | deleteColumns (int number, const int *which)
| Deletes columns. More...
void | deleteRowsAndColumns (int numberRows, const int *whichRows, int numberColumns, const int *whichColumns)
| Deletes rows AND columns (keeps old sizes) More...
void | addColumn (int numberInColumn, const int *rows, const double *elements, double columnLower=0.0, double columnUpper=COIN_DBL_MAX, double objective=0.0)
| Add one column. More...
void | addColumns (int number, const double *columnLower, const double *columnUpper, const double *objective, const CoinBigIndex *columnStarts, const int *rows, const double *elements)
| Add columns. More...
void | addColumns (int number, const double *columnLower, const double *columnUpper, const double *objective, const CoinBigIndex *columnStarts, const int *columnLengths, const int *rows, const double *elements)
void | addColumns (int number, const double *columnLower, const double *columnUpper, const double *objective, const CoinPackedVectorBase *const *columns)
int | addColumns (const CoinBuild &buildObject, bool tryPlusMinusOne=false, bool checkDuplicates=true)
| Add columns from a build object If tryPlusMinusOne then will try adding as +-1 matrix if no matrix exists. More...
int | addColumns (CoinModel &modelObject, bool tryPlusMinusOne=false, bool checkDuplicates=true)
| Add columns from a model object. More...
void | modifyCoefficient (int row, int column, double newElement, bool keepZero=false)
| Modify one element of a matrix. More...
void | chgRowLower (const double *rowLower)
| Change row lower bounds. More...
void | chgRowUpper (const double *rowUpper)
| Change row upper bounds. More...
void | chgColumnLower (const double *columnLower)
| Change column lower bounds. More...
void | chgColumnUpper (const double *columnUpper)
| Change column upper bounds. More...
void | chgObjCoefficients (const double *objIn)
| Change objective coefficients. More...
void | borrowModel (ClpModel &otherModel)
| Borrow model. More...
void | returnModel (ClpModel &otherModel)
| Return model - nulls all arrays so can be deleted safely also updates any scalars. More...
void | createEmptyMatrix ()
| Create empty ClpPackedMatrix. More...
CoinBigIndex | cleanMatrix (double threshold=1.0e-20)
| Really clean up matrix (if ClpPackedMatrix). More...
void | copy (const ClpMatrixBase *from, ClpMatrixBase *&to)
| Copy contents - resizing if necessary - otherwise re-use memory. More...
void | dropNames ()
| Drops names - makes lengthnames 0 and names empty. More...
void | copyNames (const std::vector< std::string > &rowNames, const std::vector< std::string > &columnNames)
| Copies in names. More...
void | copyRowNames (const std::vector< std::string > &rowNames, int first, int last)
| Copies in Row names - modifies names first .. last-1. More...
void | copyColumnNames (const std::vector< std::string > &columnNames, int first, int last)
| Copies in Column names - modifies names first .. last-1. More...
void | copyRowNames (const char *const *rowNames, int first, int last)
| Copies in Row names - modifies names first .. last-1. More...
void | copyColumnNames (const char *const *columnNames, int first, int last)
| Copies in Column names - modifies names first .. last-1. More...
void | setRowName (int rowIndex, std::string &name)
| Set name of row. More...
void | setColumnName (int colIndex, std::string &name)
| Set name of col. More...
int | findNetwork (char *rotate, double fractionNeeded=0.75)
| Find a network subset. More...
CoinModel * | createCoinModel () const
| This creates a coinModel object. More...
int | writeMps (const char *filename, int formatType=0, int numberAcross=2, double objSense=0.0) const
| Write the problem in MPS format to the specified file. More...
int | numberRows () const
| Number of rows. More...
int | getNumRows () const
int | getNumCols () const
| Number of columns. More...
int | numberColumns () const
double | primalTolerance () const
| Primal tolerance to use. More...
void | setPrimalTolerance (double value)
double | dualTolerance () const
| Dual tolerance to use. More...
void | setDualTolerance (double value)
double | primalObjectiveLimit () const
| Primal objective limit. More...
void | setPrimalObjectiveLimit (double value)
double | dualObjectiveLimit () const
| Dual objective limit. More...
void | setDualObjectiveLimit (double value)
double | objectiveOffset () const
| Objective offset. More...
void | setObjectiveOffset (double value)
double | presolveTolerance () const
| Presolve tolerance to use. More...
const std::string & | problemName () const
int | numberIterations () const
| Number of iterations. More...
int | getIterationCount () const
void | setNumberIterations (int numberIterationsNew)
int | solveType () const
| Solve type - 1 simplex, 2 simplex interface, 3 Interior. More...
void | setSolveType (int type)
int | maximumIterations () const
| Maximum number of iterations. More...
void | setMaximumIterations (int value)
double | maximumSeconds () const
| Maximum time in seconds (from when set called) More...
void | setMaximumSeconds (double value)
void | setMaximumWallSeconds (double value)
bool | hitMaximumIterations () const
| Returns true if hit maximum iterations (or time) More...
int | status () const
| Status of problem: -1 - unknown e.g. More...
int | problemStatus () const
void | setProblemStatus (int problemStatusNew)
| Set problem status. More...
int | secondaryStatus () const
| Secondary status of problem - may get extended 0 - none 1 - primal infeasible because dual limit reached OR (probably primal infeasible but can't prove it - main status was 4) 2 - scaled problem optimal - unscaled problem has primal infeasibilities 3 - scaled problem optimal - unscaled problem has dual infeasibilities 4 - scaled problem optimal - unscaled problem has primal and dual infeasibilities 5 - giving up in primal with flagged variables 6 - failed due to empty problem check 7 - postSolve says not optimal 8 - failed due to bad element check 9 - status was 3 and stopped on time 10 - status was 3 but stopped as primal feasible 100 up - translation of enum from ClpEventHandler. More...
void | setSecondaryStatus (int newstatus)
bool | isAbandoned () const
| Are there a numerical difficulties? More...
bool | isProvenOptimal () const
| Is optimality proven? More...
bool | isProvenPrimalInfeasible () const
| Is primal infeasiblity proven? More...
bool | isProvenDualInfeasible () const
| Is dual infeasiblity proven? More...
bool | isPrimalObjectiveLimitReached () const
| Is the given primal objective limit reached? More...
bool | isDualObjectiveLimitReached () const
| Is the given dual objective limit reached? More...
bool | isIterationLimitReached () const
| Iteration limit reached? More...
double | optimizationDirection () const
| Direction of optimization (1 - minimize, -1 - maximize, 0 - ignore. More...
double | getObjSense () const
void | setOptimizationDirection (double value)
double * | primalRowSolution () const
| Primal row solution. More...
const double * | getRowActivity () const
double * | primalColumnSolution () const
| Primal column solution. More...
const double * | getColSolution () const
void | setColSolution (const double *input)
double * | dualRowSolution () const
| Dual row solution. More...
const double * | getRowPrice () const
double * | dualColumnSolution () const
| Reduced costs. More...
const double * | getReducedCost () const
double * | rowLower () const
| Row lower. More...
const double * | getRowLower () const
double * | rowUpper () const
| Row upper. More...
const double * | getRowUpper () const
void | setObjectiveCoefficient (int elementIndex, double elementValue)
| Set an objective function coefficient. More...
void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient. More...
void | setColumnLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -DBL_MAX for -infinity. More...
void | setColumnUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use DBL_MAX for infinity. More...
void | setColumnBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound. More...
void | setColumnSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously The default implementation just invokes setColLower() and setColUpper() over and over again. More...
void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -DBL_MAX for -infinity. More...
void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use DBL_MAX for infinity. More...
void | setColBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound. More...
void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously More...
void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -DBL_MAX for -infinity. More...
void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use DBL_MAX for infinity. More...
void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound. More...
void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of rows simultaneously More...
void | passInMessageHandler (CoinMessageHandler *handler)
| Pass in Message handler (not deleted at end) More...
CoinMessageHandler * | pushMessageHandler (CoinMessageHandler *handler, bool &oldDefault)
| Pass in Message handler (not deleted at end) and return current. More...
void | popMessageHandler (CoinMessageHandler *oldHandler, bool oldDefault)
| back to previous message handler More...
void | newLanguage (CoinMessages::Language language)
| Set language. More...
void | setLanguage (CoinMessages::Language language)
void | setDefaultMessageHandler ()
| Overrides message handler with a default one. More...
CoinMessageHandler * | messageHandler () const
| Return handler. More...
CoinMessages | messages () const
| Return messages. More...
CoinMessages * | messagesPointer ()
| Return pointer to messages. More...
CoinMessages | coinMessages () const
| Return Coin messages. More...
CoinMessages * | coinMessagesPointer ()
| Return pointer to Coin messages. More...
void | setLogLevel (int value)
| Amount of print out: 0 - none 1 - just final 2 - just factorizations 3 - as 2 plus a bit more 4 - verbose above that 8,16,32 etc just for selective debug. More...
int | logLevel () const
bool | defaultHandler () const
| Return true if default handler. More...
void | passInEventHandler (const ClpEventHandler *eventHandler)
| Pass in Event handler (cloned and deleted at end) More...
ClpEventHandler * | eventHandler () const
| Event handler. More...
CoinThreadRandom * | randomNumberGenerator ()
| Thread specific random number generator. More...
CoinThreadRandom & | mutableRandomNumberGenerator ()
| Thread specific random number generator. More...
void | setRandomSeed (int value)
| Set seed for thread specific random number generator. More...
int | lengthNames () const
| length of names (0 means no names0 More...
void | setLengthNames (int value)
| length of names (0 means no names0 More...
const std::vector< std::string > * | rowNames () const
| Row names. More...
const std::string & | rowName (int iRow) const
std::string | getRowName (int iRow) const
| Return name or Rnnnnnnn. More...
const std::vector< std::string > * | columnNames () const
| Column names. More...
const std::string & | columnName (int iColumn) const
std::string | getColumnName (int iColumn) const
| Return name or Cnnnnnnn. More...
ClpObjective * | objectiveAsObject () const
| Objective methods. More...
void | setObjective (ClpObjective *objective)
void | setObjectivePointer (ClpObjective *newobjective)
int | emptyProblem (int *infeasNumber=NULL, double *infeasSum=NULL, bool printMessage=true)
| Solve a problem with no elements - return status and dual and primal infeasibilites. More...
void | times (double scalar, const double *x, double *y) const
| Return `y + A * x * scalar` in `y`. More...
void | transposeTimes (double scalar, const double *x, double *y) const
| Return `y + x * scalar * A` in `y`. More...
bool | setIntParam (ClpIntParam key, int value)
| Set an integer parameter. More...
bool | setDblParam (ClpDblParam key, double value)
| Set an double parameter. More...
bool | setStrParam (ClpStrParam key, const std::string &value)
| Set an string parameter. More...
bool | getIntParam (ClpIntParam key, int &value) const
bool | getDblParam (ClpDblParam key, double &value) const
bool | getStrParam (ClpStrParam key, std::string &value) const
void | generateCpp (FILE *fp)
| Create C++ lines to get to current state. More...
unsigned int | specialOptions () const
| For advanced options 1 - Don't keep changing infeasibility weight 2 - Keep nonLinearCost round solves 4 - Force outgoing variables to exact bound (primal) 8 - Safe to use dense initial factorization 16 -Just use basic variables for operation if column generation 32 -Create ray even in BAB 64 -Treat problem as feasible until last minute (i.e. More...
void | setSpecialOptions (unsigned int value)
bool | inCbcBranchAndBound () const

## Protected Member Functions
protected methods
int | gutsOfSolution (double *givenDuals, const double *givenPrimals, bool valuesPass=false)
| May change basis and then returns number changed. More...
void | gutsOfDelete (int type)
| Does most of deletion (0 = all, 1 = most, 2 most + factorization) More...
void | gutsOfCopy (const ClpSimplex &rhs)
| Does most of copying. More...
bool | createRim (int what, bool makeRowCopy=false, int startFinishOptions=0)
| puts in format I like (rowLower,rowUpper) also see StandardMatrix 1 bit does rows (now and columns), (2 bit does column bounds), 4 bit does objective(s). More...
void | createRim1 (bool initial)
| Does rows and columns. More...
void | createRim4 (bool initial)
| Does objective. More...
void | createRim5 (bool initial)
| Does rows and columns and objective. More...
void | deleteRim (int getRidOfFactorizationData=2)
| releases above arrays and does solution scaling out. More...
bool | sanityCheck ()
| Sanity check on input rim data (after scaling) - returns true if okay. More...
Protected Member Functions inherited from ClpModel
void | gutsOfDelete (int type)
| Does most of deletion (0 = all, 1 = most) More...
void | gutsOfCopy (const ClpModel &rhs, int trueCopy=1)
| Does most of copying If trueCopy 0 then just points to arrays If -1 leaves as much as possible. More...
void | getRowBound (int iRow, double &lower, double &upper) const
| gets lower and upper bounds on rows More...
void | gutsOfLoadModel (int numberRows, int numberColumns, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub, const double *rowObjective=NULL)
| puts in format I like - 4 array matrix - may make row copy More...
void | gutsOfScaling ()
| Does much of scaling. More...
double | rawObjectiveValue () const
| Objective value - always minimize. More...
bool | permanentArrays () const
| If we are using maximumRows_ and Columns_. More...
void | startPermanentArrays ()
| Start using maximumRows_ and Columns_. More...
void | stopPermanentArrays ()
| Stop using maximumRows_ and Columns_. More...
const char *const * | rowNamesAsChar () const
| Create row names as char **. More...
const char *const * | columnNamesAsChar () const
| Create column names as char **. More...
void | deleteNamesAsChar (const char *const *names, int number) const
| Delete char * version of names. More...
void | onStopped ()
| On stopped - sets secondary status. More...

## Friends
void | ClpSimplexUnitTest (const std::string &mpsDir)
| A function that tests the methods in the ClpSimplex class. More...

## Functions less likely to be useful to casual user
int | getSolution (const double *rowActivities, const double *columnActivities)
| Given an existing factorization computes and checks primal and dual solutions. More...
int | getSolution ()
| Given an existing factorization computes and checks primal and dual solutions. More...
int | createPiecewiseLinearCosts (const int *starts, const double *lower, const double *gradient)
| Constructs a non linear cost from list of non-linearities (columns only) First lower of each column is taken as real lower Last lower is taken as real upper and cost ignored. More...
ClpDualRowPivot * | dualRowPivot () const
| dual row pivot choice More...
ClpPrimalColumnPivot * | primalColumnPivot () const
| primal column pivot choice More...
bool | goodAccuracy () const
| Returns true if model looks OK. More...
void | returnModel (ClpSimplex &otherModel)
| Return model - updates any scalars. More...
int | internalFactorize (int solveType)
| Factorizes using current basis. More...
ClpDataSave | saveData ()
| Save data. More...
void | restoreData (ClpDataSave saved)
| Restore data. More...
void | cleanStatus ()
| Clean up status. More...
int | factorize ()
| Factorizes using current basis. For external use. More...
void | computeDuals (double *givenDjs)
| Computes duals from scratch. More...
void | computePrimals (const double *rowActivities, const double *columnActivities)
| Computes primals from scratch. More...
void | add (double *array, int column, double multiplier) const
| Adds multiple of a column into an array. More...
void | unpack (CoinIndexedVector *rowArray) const
| Unpacks one column of the matrix into indexed array Uses sequenceIn_ Also applies scaling if needed. More...
void | unpack (CoinIndexedVector *rowArray, int sequence) const
| Unpacks one column of the matrix into indexed array Slack if sequence>= numberColumns Also applies scaling if needed. More...
void | unpackPacked (CoinIndexedVector *rowArray)
| Unpacks one column of the matrix into indexed array as packed vector Uses sequenceIn_ Also applies scaling if needed. More...
void | unpackPacked (CoinIndexedVector *rowArray, int sequence)
| Unpacks one column of the matrix into indexed array as packed vector Slack if sequence>= numberColumns Also applies scaling if needed. More...
void | setValuesPassAction (double incomingInfeasibility, double allowedInfeasibility)
| For advanced use. More...
int | cleanFactorization (int ifValuesPass)
| Get a clean factorization - i.e. More...
int | housekeeping (double objectiveChange)
| This does basis housekeeping and does values for in/out variables. More...
void | checkPrimalSolution (const double *rowActivities=NULL, const double *columnActivies=NULL)
| This sets largest infeasibility and most infeasible and sum and number of infeasibilities (Primal) More...
void | checkDualSolution ()
| This sets largest infeasibility and most infeasible and sum and number of infeasibilities (Dual) More...
void | checkBothSolutions ()
| This sets sum and number of infeasibilities (Dual and Primal) More...
double | scaleObjective (double value)
| If input negative scales objective so maximum <= -value and returns scale factor used. More...
int | solveDW (CoinStructuredModel *model, ClpSolve &options)
| Solve using Dantzig-Wolfe decomposition and maybe in parallel. More...
int | solveBenders (CoinStructuredModel *model, ClpSolve &options)
| Solve using Benders decomposition and maybe in parallel. More...

## data. Many arrays have a row part and a column part.
There is a single array with both - columns then rows and then normally two arrays pointing to rows and columns. The single array is the owner of memory
double | bestPossibleImprovement_
| Best possible improvement using djs (primal) or obj change by flipping bounds to make dual feasible (dual) More...
double | zeroTolerance_
| Zero tolerance. More...
int | columnPrimalSequence_
| Sequence of worst (-1 if feasible) More...
int | rowPrimalSequence_
| Sequence of worst (-1 if feasible) More...
double | bestObjectiveValue_
| "Best" objective value More...
int | moreSpecialOptions_
| More special options - see set for details. More...
int | baseIteration_
| Iteration when we entered dual or primal. More...
int | vectorMode_
| Vector mode - try and use vector instructions. More...
double | primalToleranceToGetOptimal_
| Primal tolerance needed to make dual feasible (<largeTolerance) More...
double | largeValue_
| Large bound value (for complementarity etc) More...
double | largestPrimalError_
| Largest error on Ax-b. More...
double | largestDualError_
| Largest error on basic duals. More...
double | alphaAccuracy_
| For computing whether to re-factorize. More...
double | dualBound_
| Dual bound. More...
double | alpha_
| Alpha (pivot element) More...
double | theta_
| Theta (pivot change) More...
double | lowerIn_
| Lower Bound on In variable. More...
double | valueIn_
| Value of In variable. More...
double | upperIn_
| Upper Bound on In variable. More...
double | dualIn_
| Reduced cost of In variable. More...
double | lowerOut_
| Lower Bound on Out variable. More...
double | valueOut_
| Value of Out variable. More...
double | upperOut_
| Upper Bound on Out variable. More...
double | dualOut_
| Infeasibility (dual) or ? (primal) of Out variable. More...
double | dualTolerance_
| Current dual tolerance for algorithm. More...
double | primalTolerance_
| Current primal tolerance for algorithm. More...
double | sumDualInfeasibilities_
| Sum of dual infeasibilities. More...
double | sumPrimalInfeasibilities_
| Sum of primal infeasibilities. More...
double | infeasibilityCost_
| Weight assigned to being infeasible in primal. More...
double | sumOfRelaxedDualInfeasibilities_
| Sum of Dual infeasibilities using tolerance based on error in duals. More...
double | sumOfRelaxedPrimalInfeasibilities_
| Sum of Primal infeasibilities using tolerance based on error in primals. More...
double | acceptablePivot_
| Acceptable pivot value just after factorization. More...
double | minimumPrimalTolerance_
| Minimum primal tolerance. More...
double | averageInfeasibility_ [CLP_INFEAS_SAVE]
double * | lower_
| Working copy of lower bounds (Owner of arrays below) More...
double * | rowLowerWork_
| Row lower bounds - working copy. More...
double * | columnLowerWork_
| Column lower bounds - working copy. More...
double * | upper_
| Working copy of upper bounds (Owner of arrays below) More...
double * | rowUpperWork_
| Row upper bounds - working copy. More...
double * | columnUpperWork_
| Column upper bounds - working copy. More...
double * | cost_
| Working copy of objective (Owner of arrays below) More...
double * | rowObjectiveWork_
| Row objective - working copy. More...
double * | objectiveWork_
| Column objective - working copy. More...
CoinIndexedVector * | rowArray_ [6]
| Useful row length arrays. More...
CoinIndexedVector * | columnArray_ [6]
| Useful column length arrays. More...
int | sequenceIn_
| Sequence of In variable. More...
int | directionIn_
| Direction of In, 1 going up, -1 going down, 0 not a clue. More...
int | sequenceOut_
| Sequence of Out variable. More...
int | directionOut_
| Direction of Out, 1 to upper bound, -1 to lower bound, 0 - superbasic. More...
int | pivotRow_
| Pivot Row. More...
int | lastGoodIteration_
| Last good iteration (immediately after a re-factorization) More...
double * | dj_
| Working copy of reduced costs (Owner of arrays below) More...
double * | rowReducedCost_
| Reduced costs of slacks not same as duals (or - duals) More...
double * | reducedCostWork_
| Possible scaled reduced costs. More...
double * | solution_
| Working copy of primal solution (Owner of arrays below) More...
double * | rowActivityWork_
| Row activities - working copy. More...
double * | columnActivityWork_
| Column activities - working copy. More...
int | numberDualInfeasibilities_
| Number of dual infeasibilities. More...
int | numberDualInfeasibilitiesWithoutFree_
| Number of dual infeasibilities (without free) More...
int | numberPrimalInfeasibilities_
| Number of primal infeasibilities. More...
int | numberRefinements_
| How many iterative refinements to do. More...
ClpDualRowPivot * | dualRowPivot_
| dual row pivot choice More...
ClpPrimalColumnPivot * | primalColumnPivot_
| primal column pivot choice More...
int * | pivotVariable_
| Basic variables pivoting on which rows. More...
ClpFactorization * | factorization_
| factorization More...
double * | savedSolution_
| Saved version of solution. More...
int | numberTimesOptimal_
| Number of times code has tentatively thought optimal. More...
ClpDisasterHandler * | disasterArea_
| Disaster handler. More...
int | changeMade_
| If change has been made (first attempt at stopping looping) More...
int | algorithm_
| Algorithm >0 == Primal, <0 == Dual. More...
int | forceFactorization_
| Now for some reliability aids This forces re-factorization early. More...
int | perturbation_
| Perturbation: -50 to +50 - perturb by this power of ten (-6 sounds good) 100 - auto perturb if takes too long (1.0e-6 largest nonzero) 101 - we are perturbed 102 - don't try perturbing again default is 100. More...
unsigned char * | saveStatus_
| Saved status regions. More...
ClpNonLinearCost * | nonLinearCost_
| Very wasteful way of dealing with infeasibilities in primal. More...
int | lastBadIteration_
| So we know when to be cautious. More...
int | lastFlaggedIteration_
| So we know when to open up again. More...
int | numberFake_
| Can be used for count of fake bounds (dual) or fake costs (primal) More...
int | numberChanged_
| Can be used for count of changed costs (dual) or changed bounds (primal) More...
int | progressFlag_
| Progress flag - at present 0 bit says artificials out, 1 free in. More...
int | firstFree_
| First free/super-basic variable (-1 if none) More...
int | numberExtraRows_
| Number of extra rows. More...
int | maximumBasic_
| Maximum number of basic variables - can be more than number of rows if GUB. More...
int | dontFactorizePivots_
| If may skip final factorize then allow up to this pivots (default 20) More...
double | incomingInfeasibility_
| For advanced use. More...
double | allowedInfeasibility_
int | automaticScale_
| Automatic scaling of objective and rhs and bounds. More...
int | maximumPerturbationSize_
| Maximum perturbation array size (take out when code rewritten) More...
double * | perturbationArray_
| Perturbation array (maximumPerturbationSize_) More...
ClpSimplex * | baseModel_
| A copy of model with certain state - normally without cuts. More...
ClpSimplexProgress | progress_
| For dealing with all issues of cycling etc. More...
int | numberDegeneratePivots_
| Number of degenerate pivots since last perturbed. More...
int | spareIntArray_ [4]
| Spare int array for passing information [0]!=0 switches on. More...
double | spareDoubleArray_ [4]
| Spare double array for passing information [0]!=0 switches on. More...
class | OsiClpSolverInterface
| Allow OsiClp certain perks. More...
class | OsiCLPSolverInterface
| And OsiCLP. More...

## Additional Inherited Members
Protected Attributes inherited from ClpModel
double | optimizationDirection_
| Direction of optimization (1 - minimize, -1 - maximize, 0 - ignore. More...
double | dblParam_ [ClpLastDblParam]
| Array of double parameters. More...
double | objectiveValue_
| Objective value. More...
double | smallElement_
| Small element value. More...
double | objectiveScale_
| Scaling of objective. More...
double | rhsScale_
| Scaling of rhs and bounds. More...
int | numberRows_
| Number of rows. More...
int | numberColumns_
| Number of columns. More...
double * | rowActivity_
| Row activities. More...
double * | columnActivity_
| Column activities. More...
double * | dual_
| Duals. More...
double * | reducedCost_
| Reduced costs. More...
double * | rowLower_
| Row lower. More...
double * | rowUpper_
| Row upper. More...
ClpObjective * | objective_
| Objective. More...
double * | rowObjective_
| Row Objective (? sign) - may be NULL. More...
double * | columnLower_
| Column Lower. More...
double * | columnUpper_
| Column Upper. More...
ClpMatrixBase * | matrix_
| Packed matrix. More...
ClpMatrixBase * | rowCopy_
| Row copy if wanted. More...
ClpPackedMatrix * | scaledMatrix_
| Scaled packed matrix. More...
double * | ray_
| Infeasible/unbounded ray. More...
double * | rowScale_
| Row scale factors for matrix. More...
double * | columnScale_
| Column scale factors. More...
double * | inverseRowScale_
| Inverse row scale factors for matrix (end of rowScale_) More...
double * | inverseColumnScale_
| Inverse column scale factors for matrix (end of columnScale_) More...
int | scalingFlag_
| Scale flag, 0 none, 1 equilibrium, 2 geometric, 3, auto, 4 dynamic, 5 geometric on rows. More...
unsigned char * | status_
| Status (i.e. More...
char * | integerType_
| Integer information. More...
void * | userPointer_
| User pointer for whatever reason. More...
ClpTrustedData * | trustedUserPointer_
| Trusted user pointer e.g. for heuristics. More...
int | intParam_ [ClpLastIntParam]
| Array of integer parameters. More...
int | numberIterations_
| Number of iterations. More...
int | solveType_
| Solve type - 1 simplex, 2 simplex interface, 3 Interior. More...
unsigned int | whatsChanged_
int | problemStatus_
| Status of problem. More...
int | secondaryStatus_
| Secondary status of problem. More...
int | lengthNames_
| length of names (0 means no names) More...
int | numberThreads_
| Number of threads (not very operational) More...
unsigned int | specialOptions_
| For advanced options See get and set for meaning. More...
CoinMessageHandler * | handler_
| Message handler. More...
bool | defaultHandler_
| Flag to say if default handler (so delete) More...
CoinThreadRandom | randomNumberGenerator_
| Thread specific random number generator. More...
ClpEventHandler * | eventHandler_
| Event handler. More...
std::vector< std::string > | rowNames_
| Row names. More...
std::vector< std::string > | columnNames_
| Column names. More...
CoinMessages | messages_
| Messages. More...
CoinMessages | coinMessages_
| Coin messages. More...
int | maximumColumns_
| Maximum number of columns in model. More...
int | maximumRows_
| Maximum number of rows in model. More...
int | maximumInternalColumns_
| Maximum number of columns (internal arrays) in model. More...
int | maximumInternalRows_
| Maximum number of rows (internal arrays) in model. More...
CoinPackedMatrix | baseMatrix_
| Base packed matrix. More...
CoinPackedMatrix | baseRowCopy_
| Base row copy. More...
double * | savedRowScale_
| Saved row scale factors for matrix. More...
double * | savedColumnScale_
| Saved column scale factors. More...
std::string | strParam_ [ClpLastStrParam]
| Array of string parameters. More...

## Detailed Description

This solves LPs using the simplex method.

It inherits from ClpModel and all its arrays are created at algorithm time. Originally I tried to work with model arrays but for simplicity of coding I changed to single arrays with structural variables then row variables. Some coding is still based on old style and needs cleaning up.

For a description of algorithms:

for dual see ClpSimplexDual.hpp and at top of ClpSimplexDual.cpp for primal see ClpSimplexPrimal.hpp and at top of ClpSimplexPrimal.cpp

There is an algorithm data member. + for primal variations and - for dual variations

Definition at line 106 of file ClpSimplex.hpp.

## Member Enumeration Documentation

enum ClpSimplex::Status

enums for status of various sorts.

First 4 match CoinWarmStartBasis, isFixed means fixed at lower bound and out of basis

Enumerator
isFree |
basic |
atUpperBound |
atLowerBound |
superBasic |
isFixed |

Definition at line 114 of file ClpSimplex.hpp.

enum ClpSimplex::FakeBound

Enumerator
noFake |
lowerFake |
upperFake |
bothFake |

Definition at line 123 of file ClpSimplex.hpp.

## Constructor & Destructor Documentation

ClpSimplex::ClpSimplex | ( | bool | emptyMessages = `false` | ) |

Default constructor.

ClpSimplex::ClpSimplex | ( | const ClpSimplex & | rhs,
|  | int | scalingMode = `-1`
| ) |  |

Copy constructor.

May scale depending on mode -1 leave mode as is 0 -off, 1 equilibrium, 2 geometric, 3, auto, 4 dynamic(later)

ClpSimplex::ClpSimplex | ( | const ClpModel & | rhs,
|  | int | scalingMode = `-1`
| ) |  |

Copy constructor from model.

May scale depending on mode -1 leave mode as is 0 -off, 1 equilibrium, 2 geometric, 3, auto, 4 dynamic(later)

ClpSimplex::ClpSimplex | ( | const ClpModel * | wholeModel,
|  | int | numberRows,
|  | const int * | whichRows,
|  | int | numberColumns,
|  | const int * | whichColumns,
|  | bool | dropNames = `true`,
|  | bool | dropIntegers = `true`,
|  | bool | fixOthers = `false`
| ) |  |

Subproblem constructor.

A subset of whole model is created from the row and column lists given. The new order is given by list order and duplicates are allowed. Name and integer information can be dropped Can optionally modify rhs to take into account variables NOT in list in this case duplicates are not allowed (also see getbackSolution)

ClpSimplex::ClpSimplex | ( | const ClpSimplex * | wholeModel,
|  | int | numberRows,
|  | const int * | whichRows,
|  | int | numberColumns,
|  | const int * | whichColumns,
|  | bool | dropNames = `true`,
|  | bool | dropIntegers = `true`,
|  | bool | fixOthers = `false`
| ) |  |

Subproblem constructor.

A subset of whole model is created from the row and column lists given. The new order is given by list order and duplicates are allowed. Name and integer information can be dropped Can optionally modify rhs to take into account variables NOT in list in this case duplicates are not allowed (also see getbackSolution)

ClpSimplex::ClpSimplex | ( | ClpSimplex * | wholeModel,
|  | int | numberColumns,
|  | const int * | whichColumns
| ) |  |

This constructor modifies original ClpSimplex and stores original stuff in created ClpSimplex.

It is only to be used in conjunction with originalModel

ClpSimplex::~ClpSimplex | ( |  | ) |

Destructor.

## Member Function Documentation

void ClpSimplex::originalModel | ( | ClpSimplex * | miniModel | ) |

This copies back stuff from miniModel and then deletes miniModel.

Only to be used with mini constructor

void ClpSimplex::setPersistenceFlag | ( | int | value | ) |

Array persistence flag If 0 then as now (delete/new) 1 then only do arrays if bigger needed 2 as 1 but give a bit extra if bigger needed.

void ClpSimplex::makeBaseModel | ( |  | ) |

Save a copy of model with certain state - normally without cuts.

void ClpSimplex::deleteBaseModel | ( |  | ) |

Switch off base model.

ClpSimplex* ClpSimplex::baseModel | ( |  | ) | const
| inline

See if we have base model.

Definition at line 208 of file ClpSimplex.hpp.

void ClpSimplex::setToBaseModel | ( | ClpSimplex * | model = `NULL` | ) |

Reset to base model (just size and arrays needed) If model NULL use internal copy.

ClpSimplex& ClpSimplex::operator= | ( | const ClpSimplex & | rhs | ) |

Assignment operator. This copies the data.

void ClpSimplex::loadProblem | ( | const ClpMatrixBase & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub,
|  | const double * | rowObjective = `NULL`
| ) |  |

Loads a problem (the constraints on the rows are given by lower and upper bounds).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

void ClpSimplex::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub,
|  | const double * | rowObjective = `NULL`
| ) |  |

void ClpSimplex::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const CoinBigIndex * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub,
|  | const double * | rowObjective = `NULL`
| ) |  |

Just like the other loadProblem() method except that the matrix is given in a standard column major ordered format (without gaps).

void ClpSimplex::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const CoinBigIndex * | start,
|  | const int * | index,
|  | const double * | value,
|  | const int * | length,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub,
|  | const double * | rowObjective = `NULL`
| ) |  |

This one is for after presolve to save memory.

int ClpSimplex::loadProblem | ( | CoinModel & | modelObject,
|  | bool | keepSolution = `false`
| ) |  |

This loads a model from a coinModel object - returns number of errors.

If keepSolution true and size is same as current then keeps current status and solution

int ClpSimplex::readMps | ( | const char * | filename,
|  | bool | keepNames = `false`,
|  | bool | ignoreErrors = `false`
| ) |  |

Read an mps file from the given filename.

int ClpSimplex::readGMPL | ( | const char * | filename,
|  | const char * | dataName,
|  | bool | keepNames = `false`
| ) |  |

Read GMPL files from the given filenames.

int ClpSimplex::readLp | ( | const char * | filename,
|  | const double | epsilon = `1e-5`
| ) |  |

Read file in LP format from file with name filename.

See class CoinLpIO for description of this format.

void ClpSimplex::writeLp | ( | const char * | filename,
|  | const char * | extension = `"lp"`,
|  | double | epsilon = `1e-5`,
|  | int | numberAcross = `10`,
|  | int | decimals = `5`,
|  | double | objSense = `0.0`,
|  | bool | useRowNames = `true`
| ) |  | const

Write the problem into an Lp file of the given filename.

If objSense is non zero then -1.0 forces the code to write a maximization objective and +1.0 to write a minimization one. If 0.0 then solver can do what it wants.

void ClpSimplex::borrowModel | ( | ClpModel & | otherModel | ) |

Borrow model.

This is so we dont have to copy large amounts of data around. It assumes a derived class wants to overwrite an empty model with a real one - while it does an algorithm. This is same as ClpModel one, but sets scaling on etc.

void ClpSimplex::borrowModel | ( | ClpSimplex & | otherModel | ) |

void ClpSimplex::passInEventHandler | ( | const ClpEventHandler * | eventHandler | ) |

Pass in Event handler (cloned and deleted at end)

void ClpSimplex::getbackSolution | ( | const ClpSimplex & | smallModel,
|  | const int * | whichRow,
|  | const int * | whichColumn
| ) |  |

Puts solution back into small model.

int ClpSimplex::loadNonLinear | ( | void * | info,
|  | int & | numberConstraints,
|  | ClpConstraint **& | constraints
| ) |  |

Load nonlinear part of problem from AMPL info Returns 0 if linear 1 if quadratic objective 2 if quadratic constraints 3 if nonlinear objective 4 if nonlinear constraints -1 on failure.

int ClpSimplex::initialSolve | ( | ClpSolve & | options | ) |

General solve algorithm which can do presolve.

See ClpSolve.hpp for options

int ClpSimplex::initialSolve | ( |  | ) |

Default initial solve.

int ClpSimplex::initialDualSolve | ( |  | ) |

Dual initial solve.

int ClpSimplex::initialPrimalSolve | ( |  | ) |

Primal initial solve.

int ClpSimplex::initialBarrierSolve | ( |  | ) |

Barrier initial solve.

int ClpSimplex::initialBarrierNoCrossSolve | ( |  | ) |

Barrier initial solve, not to be followed by crossover.

int ClpSimplex::dual | ( | int | ifValuesPass = `0`,
|  | int | startFinishOptions = `0`
| ) |  |

Dual algorithm - see ClpSimplexDual.hpp for method.

ifValuesPass==2 just does values pass and then stops.

startFinishOptions - bits 1 - do not delete work areas and factorization at end 2 - use old factorization if same number of rows 4 - skip as much initialization of work areas as possible (based on whatsChanged in clpmodel.hpp) ** work in progress maybe other bits later

int ClpSimplex::dualDebug | ( | int | ifValuesPass = `0`,
|  | int | startFinishOptions = `0`
| ) |  |

int ClpSimplex::primal | ( | int | ifValuesPass = `0`,
|  | int | startFinishOptions = `0`
| ) |  |

Primal algorithm - see ClpSimplexPrimal.hpp for method.

ifValuesPass==2 just does values pass and then stops.

startFinishOptions - bits 1 - do not delete work areas and factorization at end 2 - use old factorization if same number of rows 4 - skip as much initialization of work areas as possible (based on whatsChanged in clpmodel.hpp) ** work in progress maybe other bits later

int ClpSimplex::nonlinearSLP | ( | int | numberPasses,
|  | double | deltaTolerance
| ) |  |

Solves nonlinear problem using SLP - may be used as crash for other algorithms when number of iterations small.

Also exits if all problematical variables are changing less than deltaTolerance

int ClpSimplex::nonlinearSLP | ( | int | numberConstraints,
|  | ClpConstraint ** | constraints,
|  | int | numberPasses,
|  | double | deltaTolerance
| ) |  |

Solves problem with nonlinear constraints using SLP - may be used as crash for other algorithms when number of iterations small.

Also exits if all problematical variables are changing less than deltaTolerance

int ClpSimplex::barrier | ( | bool | crossover = `true` | ) |

Solves using barrier (assumes you have good cholesky factor code).

Does crossover to simplex if asked

int ClpSimplex::reducedGradient | ( | int | phase = `0` | ) |

Solves non-linear using reduced gradient.

Phase = 0 get feasible, =1 use solution

int ClpSimplex::solve | ( | CoinStructuredModel * | model | ) |

Solve using structure of model and maybe in parallel.

int ClpSimplex::loadProblem | ( | CoinStructuredModel & | modelObject,
|  | bool | originalOrder = `true`,
|  | bool | keepSolution = `false`
| ) |  |

This loads a model from a CoinStructuredModel object - returns number of errors.

If originalOrder then keep to order stored in blocks, otherwise first column/rows correspond to first block - etc. If keepSolution true and size is same as current then keeps current status and solution

int ClpSimplex::cleanup | ( | int | cleanupScaling | ) |

When scaling is on it is possible that the scaled problem is feasible but the unscaled is not.

Clp returns a secondary status code to that effect. This option allows for a cleanup. If you use it I would suggest 1. This only affects actions when scaled optimal 0 - no action 1 - clean up using dual if primal infeasibility 2 - clean up using dual if dual infeasibility 3 - clean up using dual if primal or dual infeasibility 11,12,13 - as 1,2,3 but use primal

return code as dual/primal

int ClpSimplex::cleanPrimalSolution | ( | double | exactMultiple | ) |

Clean primal solution If you expect solution to only have exact multiples of "exactMultiple" then this tries moving solution values to nearest multiple.

If still feasible then the solution is replaced.

This is designed for the case where values should be integral, but Clp may have values at e.g. 1.0e-13 Returns 0 if successful, n if n rhs violated The dual version may be written if this gets used.

int ClpSimplex::dualRanging | ( | int | numberCheck,
|  | const int * | which,
|  | double * | costIncrease,
|  | int * | sequenceIncrease,
|  | double * | costDecrease,
|  | int * | sequenceDecrease,
|  | double * | valueIncrease = `NULL`,
|  | double * | valueDecrease = `NULL`
| ) |  |

Dual ranging.

This computes increase/decrease in cost for each given variable and corresponding sequence numbers which would change basis. Sequence numbers are 0..numberColumns and numberColumns.. for artificials/slacks. For non-basic variables the information is trivial to compute and the change in cost is just minus the reduced cost and the sequence number will be that of the non-basic variables. For basic variables a ratio test is between the reduced costs for non-basic variables and the row of the tableau corresponding to the basic variable. The increase/decrease value is always >= 0.0

Up to user to provide correct length arrays where each array is of length numberCheck. which contains list of variables for which information is desired. All other arrays will be filled in by function. If fifth entry in which is variable 7 then fifth entry in output arrays will be information for variable 7.

If valueIncrease/Decrease not NULL (both must be NULL or both non NULL) then these are filled with the value of variable if such a change in cost were made (the existing bounds are ignored)

Returns non-zero if infeasible unbounded etc

int ClpSimplex::primalRanging | ( | int | numberCheck,
|  | const int * | which,
|  | double * | valueIncrease,
|  | int * | sequenceIncrease,
|  | double * | valueDecrease,
|  | int * | sequenceDecrease
| ) |  |

Primal ranging.

This computes increase/decrease in value for each given variable and corresponding sequence numbers which would change basis. Sequence numbers are 0..numberColumns and numberColumns.. for artificials/slacks. This should only be used for non-basic variabls as otherwise information is pretty useless For basic variables the sequence number will be that of the basic variables.

Up to user to provide correct length arrays where each array is of length numberCheck. which contains list of variables for which information is desired. All other arrays will be filled in by function. If fifth entry in which is variable 7 then fifth entry in output arrays will be information for variable 7.

Returns non-zero if infeasible unbounded etc

int ClpSimplex::modifyCoefficientsAndPivot | ( | int | number,
|  | const int * | which,
|  | const CoinBigIndex * | start,
|  | const int * | row,
|  | const double * | newCoefficient,
|  | const unsigned char * | newStatus = `NULL`,
|  | const double * | newLower = `NULL`,
|  | const double * | newUpper = `NULL`,
|  | const double * | newObjective = `NULL`
| ) |  |

Modifies coefficients etc and if necessary pivots in and out.

All at same status will be done (basis may go singular). User can tell which others have been done (i.e. if status matches). If called from outside will change status and return 0. If called from event handler returns non-zero if user has to take action. indices>=numberColumns are slacks (obviously no coefficients) status array is (char) Status enum

int ClpSimplex::outDuplicateRows | ( | int | numberLook,
|  | int * | whichRows,
|  | bool | noOverlaps = `false`,
|  | double | tolerance = `-1.0`,
|  | double | cleanUp = `0.0`
| ) |  |

Take out duplicate rows (includes scaled rows and intersections).

On exit whichRows has rows to delete - return code is number can be deleted or -1 if would be infeasible. If tolerance is -1.0 use primalTolerance for equality rows and infeasibility If cleanUp not zero then spend more time trying to leave more stable row and make row bounds exact multiple of cleanUp if close enough

double ClpSimplex::moveTowardsPrimalFeasible | ( |  | ) |

Try simple crash like techniques to get closer to primal feasibility returns final sum of infeasibilities.

void ClpSimplex::removeSuperBasicSlacks | ( | int | threshold = `0` | ) |

Try simple crash like techniques to remove super basic slacks but only if > threshold.

ClpSimplex* ClpSimplex::miniPresolve | ( | char * | rowType,
|  | char * | columnType,
|  | void ** | info
| ) |  |

Mini presolve (faster) Char arrays must be numberRows and numberColumns long on entry second part must be filled in as follows - 0 - possible >0 - take out and do something (depending on value - TBD) -1 row/column can't vanish but can have entries removed/changed -2 don't touch at all on exit <=0 ones will be in presolved problem struct will be created and will be long enough (information on length etc in first entry) user must delete struct.

void ClpSimplex::miniPostsolve | ( | const ClpSimplex * | presolvedModel,
|  | void * | info
| ) |  |

After mini presolve.

void ClpSimplex::miniSolve | ( | char * | rowType,
|  | char * | columnType,
|  | int | algorithm,
|  | int | startUp
| ) |  |

mini presolve and solve

int ClpSimplex::writeBasis | ( | const char * | filename,
|  | bool | writeValues = `false`,
|  | int | formatType = `0`
| ) |  | const

Write the basis in MPS format to the specified file.

If writeValues true writes values of structurals (and adds VALUES to end of NAME card)

Row and column names may be null. formatType is

- 0 - normal
- 1 - extra accuracy
- 2 - IEEE hex (later)

Returns non-zero on I/O error

int ClpSimplex::readBasis | ( | const char * | filename | ) |

Read a basis from the given filename, returns -1 on file error, 0 if no values, 1 if values.

CoinWarmStartBasis* ClpSimplex::getBasis | ( |  | ) | const

Returns a basis (to be deleted by user)

void ClpSimplex::setFactorization | ( | ClpFactorization & | factorization | ) |

Passes in factorization.

ClpFactorization* ClpSimplex::swapFactorization | ( | ClpFactorization * | factorization | ) |

void ClpSimplex::copyFactorization | ( | ClpFactorization & | factorization | ) |

Copies in factorization to existing one.

int ClpSimplex::tightenPrimalBounds | ( | double | factor = `0.0`,
|  | int | doTight = `0`,
|  | bool | tightIntegers = `false`
| ) |  |

Tightens primal bounds to make dual faster.

Unless fixed or doTight>10, bounds are slightly looser than they could be. This is to make dual go faster and is probably not needed with a presolve. Returns non-zero if problem infeasible.

Fudge for branch and bound - put bounds on columns of factor * largest value (at continuous) - should improve stability in branch and bound on infeasible branches (0.0 is off)

int ClpSimplex::crash | ( | double | gap,
|  | int | pivot
| ) |  |

Crash - at present just aimed at dual, returns -2 if dual preferred and crash basis created -1 if dual preferred and all slack basis preferred 0 if basis going in was not all slack 1 if primal preferred and all slack basis preferred 2 if primal preferred and crash basis created.

if gap between bounds <="gap" variables can be flipped ( If pivot -1 then can be made super basic!)

If "pivot" is -1 No pivoting - always primal 0 No pivoting (so will just be choice of algorithm) 1 Simple pivoting e.g. gub 2 Mini iterations

void ClpSimplex::setDualRowPivotAlgorithm | ( | ClpDualRowPivot & | choice | ) |

Sets row pivot choice algorithm in dual.

void ClpSimplex::setPrimalColumnPivotAlgorithm | ( | ClpPrimalColumnPivot & | choice | ) |

Sets column pivot choice algorithm in primal.

void ClpSimplex::markHotStart | ( | void *& | saveStuff | ) |

Create a hotstart point of the optimization process.

void ClpSimplex::solveFromHotStart | ( | void * | saveStuff | ) |

Optimize starting from the hotstart.

void ClpSimplex::unmarkHotStart | ( | void * | saveStuff | ) |

Delete the snapshot.

int ClpSimplex::strongBranching | ( | int | numberVariables,
|  | const int * | variables,
|  | double * | newLower,
|  | double * | newUpper,
|  | double ** | outputSolution,
|  | int * | outputStatus,
|  | int * | outputIterations,
|  | bool | stopOnFirstInfeasible = `true`,
|  | bool | alwaysFinish = `false`,
|  | int | startFinishOptions = `0`
| ) |  |

For strong branching.

On input lower and upper are new bounds while on output they are change in objective function values (>1.0e50 infeasible). Return code is 0 if nothing interesting, -1 if infeasible both ways and +1 if infeasible one way (check values to see which one(s)) Solutions are filled in as well - even down, odd up - also status and number of iterations

int ClpSimplex::fathom | ( | void * | stuff | ) |

Fathom - 1 if solution.

int ClpSimplex::fathomMany | ( | void * | stuff | ) |

Do up to N deep - returns -1 - no solution nNodes_ valid nodes >= if solution and that node gives solution ClpNode array is 2**N long.

Values for N and array are in stuff (nNodes_ also in stuff)

double ClpSimplex::doubleCheck | ( |  | ) |

Double checks OK.

int ClpSimplex::startFastDual2 | ( | ClpNodeStuff * | stuff | ) |

Starts Fast dual2.

int ClpSimplex::fastDual2 | ( | ClpNodeStuff * | stuff | ) |

Like Fast dual.

void ClpSimplex::stopFastDual2 | ( | ClpNodeStuff * | stuff | ) |

Stops Fast dual2.

ClpSimplex* ClpSimplex::fastCrunch | ( | ClpNodeStuff * | stuff,
|  | int | mode
| ) |  |

Deals with crunch aspects mode 0 - in 1 - out with solution 2 - out without solution returns small model or NULL.

int ClpSimplex::pivot | ( |  | ) |

Pivot in a variable and out a variable.

Returns 0 if okay, 1 if inaccuracy forced re-factorization, -1 if would be singular. Also updates primal/dual infeasibilities. Assumes sequenceIn_ and pivotRow_ set and also directionIn and Out.

int ClpSimplex::primalPivotResult | ( |  | ) |

Pivot in a variable and choose an outgoing one.

Assumes primal feasible - will not go through a bound. Returns step length in theta Returns ray in ray_ (or NULL if no pivot) Return codes as before but -1 means no acceptable pivot

int ClpSimplex::dualPivotResultPart1 | ( |  | ) |

Pivot out a variable and choose an incoing one.

Assumes dual feasible - will not go through a reduced cost. Returns step length in theta Return codes as before but -1 means no acceptable pivot

int ClpSimplex::pivotResultPart2 | ( | int | algorithm,
|  | int | state
| ) |  |

Do actual pivot state is 0 if need tableau column, 1 if in rowArray_[1].

int ClpSimplex::startup | ( | int | ifValuesPass,
|  | int | startFinishOptions = `0`
| ) |  |

Common bits of coding for dual and primal.

Return 0 if okay, 1 if bad matrix, 2 if very bad factorization

startFinishOptions - bits 1 - do not delete work areas and factorization at end 2 - use old factorization if same number of rows 4 - skip as much initialization of work areas as possible (based on whatsChanged in clpmodel.hpp) ** work in progress maybe other bits later

void ClpSimplex::finish | ( | int | startFinishOptions = `0` | ) |

bool ClpSimplex::statusOfProblem | ( | bool | initial = `false` | ) |

Factorizes and returns true if optimal.

Used by user

void ClpSimplex::defaultFactorizationFrequency | ( |  | ) |

If user left factorization frequency then compute.

void ClpSimplex::copyEnabledStuff | ( | const ClpSimplex * | rhs | ) |

Copy across enabled stuff from one solver to another.

bool ClpSimplex::primalFeasible | ( |  | ) | const
| inline

If problem is primal feasible.

Definition at line 666 of file ClpSimplex.hpp.

bool ClpSimplex::dualFeasible | ( |  | ) | const
| inline

If problem is dual feasible.

Definition at line 671 of file ClpSimplex.hpp.

ClpFactorization* ClpSimplex::factorization | ( |  | ) | const
| inline

factorization

Definition at line 676 of file ClpSimplex.hpp.

bool ClpSimplex::sparseFactorization | ( |  | ) | const

Sparsity on or off.

void ClpSimplex::setSparseFactorization | ( | bool | value | ) |

int ClpSimplex::factorizationFrequency | ( |  | ) | const

Factorization frequency.

void ClpSimplex::setFactorizationFrequency | ( | int | value | ) |

double ClpSimplex::dualBound | ( |  | ) | const
| inline

Dual bound.

Definition at line 687 of file ClpSimplex.hpp.

void ClpSimplex::setDualBound | ( | double | value | ) |

double ClpSimplex::infeasibilityCost | ( |  | ) | const
| inline

Infeasibility cost.

Definition at line 693 of file ClpSimplex.hpp.

void ClpSimplex::setInfeasibilityCost | ( | double | value | ) |

int ClpSimplex::perturbation | ( |  | ) | const
| inline

Amount of print out: 0 - none 1 - just final 2 - just factorizations 3 - as 2 plus a bit more 4 - verbose above that 8,16,32 etc just for selective debug.

Perturbation: 50 - switch on perturbation 100 - auto perturb if takes too long (1.0e-6 largest nonzero) 101 - we are perturbed 102 - don't try perturbing again default is 100 others are for playing

Definition at line 714 of file ClpSimplex.hpp.

void ClpSimplex::setPerturbation | ( | int | value | ) |

int ClpSimplex::algorithm | ( |  | ) | const
| inline

Current (or last) algorithm.

Definition at line 720 of file ClpSimplex.hpp.

void ClpSimplex::setAlgorithm | ( | int | value | ) |
| inline

Set algorithm.

Definition at line 725 of file ClpSimplex.hpp.

bool ClpSimplex::isObjectiveLimitTestValid | ( |  | ) | const

Return true if the objective limit test can be relied upon.

double ClpSimplex::sumDualInfeasibilities | ( |  | ) | const
| inline

Sum of dual infeasibilities.

Definition at line 732 of file ClpSimplex.hpp.

void ClpSimplex::setSumDualInfeasibilities | ( | double | value | ) |
| inline

Definition at line 736 of file ClpSimplex.hpp.

double ClpSimplex::sumOfRelaxedDualInfeasibilities | ( |  | ) | const
| inline

Sum of relaxed dual infeasibilities.

Definition at line 741 of file ClpSimplex.hpp.

void ClpSimplex::setSumOfRelaxedDualInfeasibilities | ( | double | value | ) |
| inline

Definition at line 745 of file ClpSimplex.hpp.

int ClpSimplex::numberDualInfeasibilities | ( |  | ) | const
| inline

Number of dual infeasibilities.

Definition at line 750 of file ClpSimplex.hpp.

void ClpSimplex::setNumberDualInfeasibilities | ( | int | value | ) |
| inline

Definition at line 754 of file ClpSimplex.hpp.

int ClpSimplex::numberDualInfeasibilitiesWithoutFree | ( |  | ) | const
| inline

Number of dual infeasibilities (without free)

Definition at line 759 of file ClpSimplex.hpp.

double ClpSimplex::sumPrimalInfeasibilities | ( |  | ) | const
| inline

Sum of primal infeasibilities.

Definition at line 764 of file ClpSimplex.hpp.

void ClpSimplex::setSumPrimalInfeasibilities | ( | double | value | ) |
| inline

Definition at line 768 of file ClpSimplex.hpp.

double ClpSimplex::sumOfRelaxedPrimalInfeasibilities | ( |  | ) | const
| inline

Sum of relaxed primal infeasibilities.

Definition at line 773 of file ClpSimplex.hpp.

void ClpSimplex::setSumOfRelaxedPrimalInfeasibilities | ( | double | value | ) |
| inline

Definition at line 777 of file ClpSimplex.hpp.

int ClpSimplex::numberPrimalInfeasibilities | ( |  | ) | const
| inline

Number of primal infeasibilities.

Definition at line 782 of file ClpSimplex.hpp.

void ClpSimplex::setNumberPrimalInfeasibilities | ( | int | value | ) |
| inline

Definition at line 786 of file ClpSimplex.hpp.

int ClpSimplex::saveModel | ( | const char * | fileName | ) |

Save model to file, returns 0 if success.

This is designed for use outside algorithms so does not save iterating arrays etc. It does not save any messaging information. Does not save scaling values. It does not know about all types of virtual functions.

int ClpSimplex::restoreModel | ( | const char * | fileName | ) |

Restore model from file, returns 0 if success, deletes current model.

void ClpSimplex::checkSolution | ( | int | setToBounds = `0` | ) |

Just check solution (for external use) - sets sum of infeasibilities etc.

If setToBounds 0 then primal column values not changed and used to compute primal row activity values. If 1 or 2 then status used - so all nonbasic variables set to indicated bound and if any values changed (or ==2) basic values re-computed.

void ClpSimplex::checkSolutionInternal | ( |  | ) |

Just check solution (for internal use) - sets sum of infeasibilities etc.

void ClpSimplex::checkUnscaledSolution | ( |  | ) |

Check unscaled primal solution but allow for rounding error.

CoinIndexedVector* ClpSimplex::rowArray | ( | int | index | ) | const
| inline

Useful row length arrays (0,1,2,3,4,5)

Definition at line 815 of file ClpSimplex.hpp.

CoinIndexedVector* ClpSimplex::columnArray | ( | int | index | ) | const
| inline

Useful column length arrays (0,1,2,3,4,5)

Definition at line 820 of file ClpSimplex.hpp.

int ClpSimplex::getSolution | ( | const double * | rowActivities,
|  | const double * | columnActivities
| ) |  |

Given an existing factorization computes and checks primal and dual solutions.

Uses input arrays for variables at bounds. Returns feasibility states

int ClpSimplex::getSolution | ( |  | ) |

Given an existing factorization computes and checks primal and dual solutions.

Uses current problem arrays for bounds. Returns feasibility states

int ClpSimplex::createPiecewiseLinearCosts | ( | const int * | starts,
|  | const double * | lower,
|  | const double * | gradient
| ) |  |

Constructs a non linear cost from list of non-linearities (columns only) First lower of each column is taken as real lower Last lower is taken as real upper and cost ignored.

Returns nonzero if bad data e.g. lowers not monotonic

ClpDualRowPivot* ClpSimplex::dualRowPivot | ( |  | ) | const
| inline

dual row pivot choice

Definition at line 847 of file ClpSimplex.hpp.

ClpPrimalColumnPivot* ClpSimplex::primalColumnPivot | ( |  | ) | const
| inline

primal column pivot choice

Definition at line 852 of file ClpSimplex.hpp.

bool ClpSimplex::goodAccuracy | ( |  | ) | const
| inline

Returns true if model looks OK.

Definition at line 857 of file ClpSimplex.hpp.

void ClpSimplex::returnModel | ( | ClpSimplex & | otherModel | ) |

Return model - updates any scalars.

int ClpSimplex::internalFactorize | ( | int | solveType | ) |

Factorizes using current basis.

solveType - 1 iterating, 0 initial, -1 external If 10 added then in primal values pass Return codes are as from ClpFactorization unless initial factorization when total number of singularities is returned. Special case is numberRows_+1 -> all slack basis.

ClpDataSave ClpSimplex::saveData | ( |  | ) |

Save data.

void ClpSimplex::restoreData | ( | ClpDataSave | saved | ) |

Restore data.

void ClpSimplex::cleanStatus | ( |  | ) |

Clean up status.

int ClpSimplex::factorize | ( |  | ) |

Factorizes using current basis. For external use.

void ClpSimplex::computeDuals | ( | double * | givenDjs | ) |

Computes duals from scratch.

If givenDjs then allows for nonzero basic djs

void ClpSimplex::computePrimals | ( | const double * | rowActivities,
|  | const double * | columnActivities
| ) |  |

Computes primals from scratch.

void ClpSimplex::add | ( | double * | array,
|  | int | column,
|  | double | multiplier
| ) |  | const

Adds multiple of a column into an array.

void ClpSimplex::unpack | ( | CoinIndexedVector * | rowArray | ) | const

Unpacks one column of the matrix into indexed array Uses sequenceIn_ Also applies scaling if needed.

void ClpSimplex::unpack | ( | CoinIndexedVector * | rowArray,
|  | int | sequence
| ) |  | const

Unpacks one column of the matrix into indexed array Slack if sequence>= numberColumns Also applies scaling if needed.

void ClpSimplex::unpackPacked | ( | CoinIndexedVector * | rowArray | ) |

Unpacks one column of the matrix into indexed array as packed vector Uses sequenceIn_ Also applies scaling if needed.

void ClpSimplex::unpackPacked | ( | CoinIndexedVector * | rowArray,
|  | int | sequence
| ) |  |

Unpacks one column of the matrix into indexed array as packed vector Slack if sequence>= numberColumns Also applies scaling if needed.

int ClpSimplex::housekeeping | ( | double | objectiveChange | ) |
| protected

This does basis housekeeping and does values for in/out variables.

Can also decide to re-factorize

void ClpSimplex::checkPrimalSolution | ( | const double * | rowActivities = `NULL`,
|  | const double * | columnActivies = `NULL`
| ) |  |
| protected

This sets largest infeasibility and most infeasible and sum and number of infeasibilities (Primal)

void ClpSimplex::checkDualSolution | ( |  | ) |
| protected

This sets largest infeasibility and most infeasible and sum and number of infeasibilities (Dual)

void ClpSimplex::checkBothSolutions | ( |  | ) |
| protected

This sets sum and number of infeasibilities (Dual and Primal)

double ClpSimplex::scaleObjective | ( | double | value | ) |
| protected

If input negative scales objective so maximum <= -value and returns scale factor used.

If positive unscales and also redoes dual stuff

int ClpSimplex::solveDW | ( | CoinStructuredModel * | model,
|  | ClpSolve & | options
| ) |  |
| protected

Solve using Dantzig-Wolfe decomposition and maybe in parallel.

int ClpSimplex::solveBenders | ( | CoinStructuredModel * | model,
|  | ClpSolve & | options
| ) |  |
| protected

Solve using Benders decomposition and maybe in parallel.

void ClpSimplex::setValuesPassAction | ( | double | incomingInfeasibility,
|  | double | allowedInfeasibility
| ) |  |

For advanced use.

When doing iterative solves things can get nasty so on values pass if incoming solution has largest infeasibility < incomingInfeasibility throw out variables from basis until largest infeasibility < allowedInfeasibility or incoming largest infeasibility. If allowedInfeasibility>= incomingInfeasibility this is always possible altough you may end up with an all slack basis.

Defaults are 1.0,10.0

int ClpSimplex::cleanFactorization | ( | int | ifValuesPass | ) |

Get a clean factorization - i.e.

throw out singularities may do more later

double ClpSimplex::alphaAccuracy | ( |  | ) | const
| inline

Initial value for alpha accuracy calculation (-1.0 off)

Definition at line 962 of file ClpSimplex.hpp.

void ClpSimplex::setAlphaAccuracy | ( | double | value | ) |
| inline

Definition at line 966 of file ClpSimplex.hpp.

void ClpSimplex::setDisasterHandler | ( | ClpDisasterHandler * | handler | ) |
| inline

Objective value.

Set disaster handler

Definition at line 977 of file ClpSimplex.hpp.

ClpDisasterHandler* ClpSimplex::disasterHandler | ( |  | ) | const
| inline

Get disaster handler.

Definition at line 982 of file ClpSimplex.hpp.

double ClpSimplex::largeValue | ( |  | ) | const
| inline

Large bound value (for complementarity etc)

Definition at line 987 of file ClpSimplex.hpp.

void ClpSimplex::setLargeValue | ( | double | value | ) |

double ClpSimplex::largestPrimalError | ( |  | ) | const
| inline

Largest error on Ax-b.

Definition at line 993 of file ClpSimplex.hpp.

double ClpSimplex::largestDualError | ( |  | ) | const
| inline

Largest error on basic duals.

Definition at line 998 of file ClpSimplex.hpp.

void ClpSimplex::setLargestPrimalError | ( | double | value | ) |
| inline

Largest error on Ax-b.

Definition at line 1003 of file ClpSimplex.hpp.

void ClpSimplex::setLargestDualError | ( | double | value | ) |
| inline

Largest error on basic duals.

Definition at line 1008 of file ClpSimplex.hpp.

double ClpSimplex::zeroTolerance | ( |  | ) | const
| inline

Get zero tolerance.

Definition at line 1013 of file ClpSimplex.hpp.

void ClpSimplex::setZeroTolerance | ( | double | value | ) |
| inline

Set zero tolerance.

Definition at line 1018 of file ClpSimplex.hpp.

int* ClpSimplex::pivotVariable | ( |  | ) | const
| inline

Basic variables pivoting on which rows.

Definition at line 1023 of file ClpSimplex.hpp.

bool ClpSimplex::automaticScaling | ( |  | ) | const
| inline

If automatic scaling on.

Definition at line 1028 of file ClpSimplex.hpp.

void ClpSimplex::setAutomaticScaling | ( | bool | onOff | ) |
| inline

Definition at line 1032 of file ClpSimplex.hpp.

double ClpSimplex::currentDualTolerance | ( |  | ) | const
| inline

Current dual tolerance.

Definition at line 1037 of file ClpSimplex.hpp.

void ClpSimplex::setCurrentDualTolerance | ( | double | value | ) |
| inline

Definition at line 1041 of file ClpSimplex.hpp.

double ClpSimplex::currentPrimalTolerance | ( |  | ) | const
| inline

Current primal tolerance.

Definition at line 1046 of file ClpSimplex.hpp.

void ClpSimplex::setCurrentPrimalTolerance | ( | double | value | ) |
| inline

Definition at line 1050 of file ClpSimplex.hpp.

int ClpSimplex::numberRefinements | ( |  | ) | const
| inline

How many iterative refinements to do.

Definition at line 1055 of file ClpSimplex.hpp.

void ClpSimplex::setNumberRefinements | ( | int | value | ) |

double ClpSimplex::alpha | ( |  | ) | const
| inline

Alpha (pivot element) for use by classes e.g. steepestedge.

Definition at line 1061 of file ClpSimplex.hpp.

void ClpSimplex::setAlpha | ( | double | value | ) |
| inline

Definition at line 1065 of file ClpSimplex.hpp.

double ClpSimplex::dualIn | ( |  | ) | const
| inline

Reduced cost of last incoming for use by classes e.g. steepestedge.

Definition at line 1070 of file ClpSimplex.hpp.

void ClpSimplex::setDualIn | ( | double | value | ) |
| inline

Set reduced cost of last incoming to force error.

Definition at line 1075 of file ClpSimplex.hpp.

int ClpSimplex::pivotRow | ( |  | ) | const
| inline

Pivot Row for use by classes e.g. steepestedge.

Definition at line 1080 of file ClpSimplex.hpp.

void ClpSimplex::setPivotRow | ( | int | value | ) |
| inline

Definition at line 1084 of file ClpSimplex.hpp.

double ClpSimplex::valueIncomingDual | ( |  | ) | const

value of incoming variable (in Dual)

int ClpSimplex::gutsOfSolution | ( | double * | givenDuals,
|  | const double * | givenPrimals,
|  | bool | valuesPass = `false`
| ) |  |
| protected

May change basis and then returns number changed.

Computation of solutions may be overriden by given pi and solution

void ClpSimplex::gutsOfDelete | ( | int | type | ) |
| protected

Does most of deletion (0 = all, 1 = most, 2 most + factorization)

void ClpSimplex::gutsOfCopy | ( | const ClpSimplex & | rhs | ) |
| protected

Does most of copying.

bool ClpSimplex::createRim | ( | int | what,
|  | bool | makeRowCopy = `false`,
|  | int | startFinishOptions = `0`
| ) |  |
| protected

puts in format I like (rowLower,rowUpper) also see StandardMatrix 1 bit does rows (now and columns), (2 bit does column bounds), 4 bit does objective(s).

8 bit does solution scaling in 16 bit does rowArray and columnArray indexed vectors and makes row copy if wanted, also sets columnStart_ etc Also creates scaling arrays if needed. It does scaling if needed. 16 also moves solutions etc in to work arrays On 16 returns false if problem "bad" i.e. matrix or bounds bad If startFinishOptions is -1 then called by user in getSolution so do arrays but keep pivotVariable_

void ClpSimplex::createRim1 | ( | bool | initial | ) |
| protected

Does rows and columns.

void ClpSimplex::createRim4 | ( | bool | initial | ) |
| protected

Does objective.

void ClpSimplex::createRim5 | ( | bool | initial | ) |
| protected

Does rows and columns and objective.

void ClpSimplex::deleteRim | ( | int | getRidOfFactorizationData = `2` | ) |
| protected

releases above arrays and does solution scaling out.

May also get rid of factorization data - 0 get rid of nothing, 1 get rid of arrays, 2 also factorization

bool ClpSimplex::sanityCheck | ( |  | ) |
| protected

Sanity check on input rim data (after scaling) - returns true if okay.

double* ClpSimplex::solutionRegion | ( | int | section | ) | const
| inline

Return row or column sections - not as much needed as it once was.

These just map into single arrays

Definition at line 1138 of file ClpSimplex.hpp.

double* ClpSimplex::djRegion | ( | int | section | ) | const
| inline

Definition at line 1145 of file ClpSimplex.hpp.

double* ClpSimplex::lowerRegion | ( | int | section | ) | const
| inline

Definition at line 1152 of file ClpSimplex.hpp.

double* ClpSimplex::upperRegion | ( | int | section | ) | const
| inline

Definition at line 1159 of file ClpSimplex.hpp.

double* ClpSimplex::costRegion | ( | int | section | ) | const
| inline

Definition at line 1166 of file ClpSimplex.hpp.

double* ClpSimplex::solutionRegion | ( |  | ) | const
| inline

Return region as single array.

Definition at line 1174 of file ClpSimplex.hpp.

double* ClpSimplex::djRegion | ( |  | ) | const
| inline

Definition at line 1178 of file ClpSimplex.hpp.

double* ClpSimplex::lowerRegion | ( |  | ) | const
| inline

Definition at line 1182 of file ClpSimplex.hpp.

double* ClpSimplex::upperRegion | ( |  | ) | const
| inline

Definition at line 1186 of file ClpSimplex.hpp.

double* ClpSimplex::costRegion | ( |  | ) | const
| inline

Definition at line 1190 of file ClpSimplex.hpp.

Status ClpSimplex::getStatus | ( | int | sequence | ) | const
| inline

Definition at line 1194 of file ClpSimplex.hpp.

void ClpSimplex::setStatus | ( | int | sequence,
|  | Status | newstatus
| ) |  |
| inline

Definition at line 1198 of file ClpSimplex.hpp.

bool ClpSimplex::startPermanentArrays | ( |  | ) |

Start or reset using maximumRows_ and Columns_ - true if change.

void ClpSimplex::setInitialDenseFactorization | ( | bool | onOff | ) |

Normally the first factorization does sparse coding because the factorization could be singular.

This allows initial dense factorization when it is known to be safe

bool ClpSimplex::initialDenseFactorization | ( |  | ) | const

int ClpSimplex::sequenceIn | ( |  | ) | const
| inline

Return sequence In or Out.

Definition at line 1213 of file ClpSimplex.hpp.

int ClpSimplex::sequenceOut | ( |  | ) | const
| inline

Definition at line 1217 of file ClpSimplex.hpp.

void ClpSimplex::setSequenceIn | ( | int | sequence | ) |
| inline

Set sequenceIn or Out.

Definition at line 1222 of file ClpSimplex.hpp.

void ClpSimplex::setSequenceOut | ( | int | sequence | ) |
| inline

Definition at line 1226 of file ClpSimplex.hpp.

int ClpSimplex::directionIn | ( |  | ) | const
| inline

Return direction In or Out.

Definition at line 1231 of file ClpSimplex.hpp.

int ClpSimplex::directionOut | ( |  | ) | const
| inline

Definition at line 1235 of file ClpSimplex.hpp.

void ClpSimplex::setDirectionIn | ( | int | direction | ) |
| inline

Set directionIn or Out.

Definition at line 1240 of file ClpSimplex.hpp.

void ClpSimplex::setDirectionOut | ( | int | direction | ) |
| inline

Definition at line 1244 of file ClpSimplex.hpp.

double ClpSimplex::valueOut | ( |  | ) | const
| inline

Value of Out variable.

Definition at line 1249 of file ClpSimplex.hpp.

double ClpSimplex::lowerOut | ( |  | ) | const
| inline

Lower of out variable.

Definition at line 1254 of file ClpSimplex.hpp.

double ClpSimplex::upperOut | ( |  | ) | const
| inline

Upper of out variable.

Definition at line 1259 of file ClpSimplex.hpp.

void ClpSimplex::setValueOut | ( | double | value | ) |
| inline

Set value of out variable.

Definition at line 1264 of file ClpSimplex.hpp.

double ClpSimplex::dualOut | ( |  | ) | const
| inline

Dual value of Out variable.

Definition at line 1269 of file ClpSimplex.hpp.

void ClpSimplex::setDualOut | ( | double | value | ) |
| inline

Set dual value of out variable.

Definition at line 1274 of file ClpSimplex.hpp.

void ClpSimplex::setLowerOut | ( | double | value | ) |
| inline

Set lower of out variable.

Definition at line 1279 of file ClpSimplex.hpp.

void ClpSimplex::setUpperOut | ( | double | value | ) |
| inline

Set upper of out variable.

Definition at line 1284 of file ClpSimplex.hpp.

void ClpSimplex::setTheta | ( | double | value | ) |
| inline

Set theta of out variable.

Definition at line 1289 of file ClpSimplex.hpp.

int ClpSimplex::isColumn | ( | int | sequence | ) | const
| inline

Returns 1 if sequence indicates column.

Definition at line 1294 of file ClpSimplex.hpp.

int ClpSimplex::sequenceWithin | ( | int | sequence | ) | const
| inline

Returns sequence number within section.

Definition at line 1299 of file ClpSimplex.hpp.

double ClpSimplex::solution | ( | int | sequence | ) |
| inline

Return row or column values.

Definition at line 1304 of file ClpSimplex.hpp.

double& ClpSimplex::solutionAddress | ( | int | sequence | ) |
| inline

Return address of row or column values.

Definition at line 1309 of file ClpSimplex.hpp.

double ClpSimplex::reducedCost | ( | int | sequence | ) |
| inline

Definition at line 1313 of file ClpSimplex.hpp.

double& ClpSimplex::reducedCostAddress | ( | int | sequence | ) |
| inline

Definition at line 1317 of file ClpSimplex.hpp.

double ClpSimplex::lower | ( | int | sequence | ) |
| inline

Definition at line 1321 of file ClpSimplex.hpp.

double& ClpSimplex::lowerAddress | ( | int | sequence | ) |
| inline

Return address of row or column lower bound.

Definition at line 1326 of file ClpSimplex.hpp.

double ClpSimplex::upper | ( | int | sequence | ) |
| inline

Definition at line 1330 of file ClpSimplex.hpp.

double& ClpSimplex::upperAddress | ( | int | sequence | ) |
| inline

Return address of row or column upper bound.

Definition at line 1335 of file ClpSimplex.hpp.

double ClpSimplex::cost | ( | int | sequence | ) |
| inline

Definition at line 1339 of file ClpSimplex.hpp.

double& ClpSimplex::costAddress | ( | int | sequence | ) |
| inline

Return address of row or column cost.

Definition at line 1344 of file ClpSimplex.hpp.

double ClpSimplex::originalLower | ( | int | iSequence | ) | const
| inline

Return original lower bound.

Definition at line 1349 of file ClpSimplex.hpp.

double ClpSimplex::originalUpper | ( | int | iSequence | ) | const
| inline

Return original lower bound.

Definition at line 1357 of file ClpSimplex.hpp.

double ClpSimplex::theta | ( |  | ) | const
| inline

Theta (pivot change)

Definition at line 1365 of file ClpSimplex.hpp.

double ClpSimplex::lowerIn | ( |  | ) | const
| inline

Lower Bound on In variable.

Definition at line 1370 of file ClpSimplex.hpp.

double ClpSimplex::valueIn | ( |  | ) | const
| inline

Value of In variable.

Definition at line 1375 of file ClpSimplex.hpp.

double ClpSimplex::upperIn | ( |  | ) | const
| inline

Upper Bound on In variable.

Definition at line 1380 of file ClpSimplex.hpp.

double ClpSimplex::bestPossibleImprovement | ( |  | ) | const
| inline

Best possible improvement using djs (primal) or obj change by flipping bounds to make dual feasible (dual)

Definition at line 1386 of file ClpSimplex.hpp.

ClpNonLinearCost* ClpSimplex::nonLinearCost | ( |  | ) | const
| inline

Return pointer to details of costs.

Definition at line 1391 of file ClpSimplex.hpp.

void ClpSimplex::setNonLinearCost | ( | ClpNonLinearCost & | nonLinearCost | ) |

Set pointer to details of costs.

int ClpSimplex::moreSpecialOptions | ( |  | ) | const
| inline

Return more special options 1 bit - if presolve says infeasible in ClpSolve return 2 bit - if presolved problem infeasible return 4 bit - keep arrays like upper_ around 8 bit - no free or superBasic variables 16 bit - if checking replaceColumn accuracy before updating 32 bit - say optimal if primal feasible! 64 bit - give up easily in dual (and say infeasible) 128 bit - no objective, 0-1 and in B&B 256 bit - in primal from dual or vice versa 512 bit - alternative use of solveType_ 1024 bit - don't do row copy of factorization 2048 bit - perturb in complete fathoming 4096 bit - try more for complete fathoming 8192 bit - don't even think of using primal if user asks for dual (and vv) 16384 bit - in initialSolve so be more flexible 32768 bit - don't swap algorithms from dual if small infeasibility 65536 bit - perturb in postsolve cleanup (even if < 10000 rows) 131072 bit (*3) initial stateDualColumn 524288 bit - stop when primal feasible 1048576 bit - stop when primal feasible after n-1000000 iterations 2097152 bit - no primal in fastDual2 if feasible 4194304 bit - tolerances have been changed by code 8388608 bit - tolerances are dynamic (at first) 16777216 bit - if factorization kept can still declare optimal at once.

Definition at line 1423 of file ClpSimplex.hpp.

int ClpSimplex::vectorMode | ( |  | ) | const
| inline

Get vector mode.

Definition at line 1428 of file ClpSimplex.hpp.

void ClpSimplex::setMoreSpecialOptions | ( | int | value | ) |
| inline

Set more special options 1 bit - if presolve says infeasible in ClpSolve return 2 bit - if presolved problem infeasible return 4 bit - keep arrays like upper_ around 8 bit - no free or superBasic variables 16 bit - if checking replaceColumn accuracy before updating 32 bit - say optimal if primal feasible! 64 bit - give up easily in dual (and say infeasible) 128 bit - no objective, 0-1 and in B&B 256 bit - in primal from dual or vice versa 512 bit - alternative use of solveType_ 1024 bit - don't do row copy of factorization 2048 bit - perturb in complete fathoming 4096 bit - try more for complete fathoming 8192 bit - don't even think of using primal if user asks for dual (and vv) 16384 bit - in initialSolve so be more flexible 32768 bit - don't swap algorithms from dual if small infeasibility 65536 bit - perturb in postsolve cleanup (even if < 10000 rows) 131072 bit (*3) initial stateDualColumn 524288 bit - stop when primal feasible 1048576 bit - don't perturb even if long time 2097152 bit - no primal in fastDual2 if feasible 4194304 bit - tolerances have been changed by code 8388608 bit - tolerances are dynamic (at first) 16777216 bit - if factorization kept can still declare optimal at once.

Definition at line 1458 of file ClpSimplex.hpp.

void ClpSimplex::setVectorMode | ( | int | value | ) |
| inline

Set vector mode.

Definition at line 1463 of file ClpSimplex.hpp.

void ClpSimplex::setFakeBound | ( | int | sequence,
|  | FakeBound | fakeBound
| ) |  |
| inline

Definition at line 1470 of file ClpSimplex.hpp.

FakeBound ClpSimplex::getFakeBound | ( | int | sequence | ) | const
| inline

Definition at line 1476 of file ClpSimplex.hpp.

void ClpSimplex::setRowStatus | ( | int | sequence,
|  | Status | newstatus
| ) |  |
| inline

Definition at line 1480 of file ClpSimplex.hpp.

Status ClpSimplex::getRowStatus | ( | int | sequence | ) | const
| inline

Definition at line 1486 of file ClpSimplex.hpp.

void ClpSimplex::setColumnStatus | ( | int | sequence,
|  | Status | newstatus
| ) |  |
| inline

Definition at line 1490 of file ClpSimplex.hpp.

Status ClpSimplex::getColumnStatus | ( | int | sequence | ) | const
| inline

Definition at line 1496 of file ClpSimplex.hpp.

void ClpSimplex::setPivoted | ( | int | sequence | ) |
| inline

Definition at line 1500 of file ClpSimplex.hpp.

void ClpSimplex::clearPivoted | ( | int | sequence | ) |
| inline

Definition at line 1504 of file ClpSimplex.hpp.

bool ClpSimplex::pivoted | ( | int | sequence | ) | const
| inline

Definition at line 1508 of file ClpSimplex.hpp.

void ClpSimplex::setFlagged | ( | int | sequence | ) |

To flag a variable (not inline to allow for column generation)

void ClpSimplex::clearFlagged | ( | int | sequence | ) |
| inline

Definition at line 1514 of file ClpSimplex.hpp.

bool ClpSimplex::flagged | ( | int | sequence | ) | const
| inline

Definition at line 1518 of file ClpSimplex.hpp.

void ClpSimplex::setActive | ( | int | iRow | ) |
| inline

To say row active in primal pivot row choice.

Definition at line 1523 of file ClpSimplex.hpp.

void ClpSimplex::clearActive | ( | int | iRow | ) |
| inline

Definition at line 1527 of file ClpSimplex.hpp.

bool ClpSimplex::active | ( | int | iRow | ) | const
| inline

Definition at line 1531 of file ClpSimplex.hpp.

void ClpSimplex::setPerturbed | ( | int | iSequence | ) |
| inline

To say perturbed.

Definition at line 1536 of file ClpSimplex.hpp.

void ClpSimplex::clearPerturbed | ( | int | iSequence | ) |
| inline

Definition at line 1540 of file ClpSimplex.hpp.

bool ClpSimplex::perturbed | ( | int | iSequence | ) | const
| inline

Definition at line 1544 of file ClpSimplex.hpp.

void ClpSimplex::createStatus | ( |  | ) |

Set up status array (can be used by OsiClp).

Also can be used to set up all slack basis

void ClpSimplex::allSlackBasis | ( | bool | resetSolution = `false` | ) |

Sets up all slack basis and resets solution to as it was after initial load or readMps.

int ClpSimplex::lastBadIteration | ( |  | ) | const
| inline

So we know when to be cautious.

Definition at line 1556 of file ClpSimplex.hpp.

void ClpSimplex::setLastBadIteration | ( | int | value | ) |
| inline

Set so we know when to be cautious.

Definition at line 1561 of file ClpSimplex.hpp.

int ClpSimplex::progressFlag | ( |  | ) | const
| inline

Progress flag - at present 0 bit says artificials out.

Definition at line 1566 of file ClpSimplex.hpp.

ClpSimplexProgress* ClpSimplex::progress | ( |  | ) |
| inline

For dealing with all issues of cycling etc.

Definition at line 1571 of file ClpSimplex.hpp.

int ClpSimplex::forceFactorization | ( |  | ) | const
| inline

Force re-factorization early value.

Definition at line 1576 of file ClpSimplex.hpp.

void ClpSimplex::forceFactorization | ( | int | value | ) |
| inline

Force re-factorization early.

Definition at line 1581 of file ClpSimplex.hpp.

double ClpSimplex::rawObjectiveValue | ( |  | ) | const
| inline

Raw objective value (so always minimize in primal)

Definition at line 1586 of file ClpSimplex.hpp.

void ClpSimplex::computeObjectiveValue | ( | bool | useWorkingSolution = `false` | ) |

Compute objective value from solution and put in objectiveValue_.

double ClpSimplex::computeInternalObjectiveValue | ( |  | ) |

Compute minimization objective value from internal solution without perturbation.

double* ClpSimplex::infeasibilityRay | ( | bool | fullRay = `false` | ) | const

Infeasibility/unbounded ray (NULL returned if none/wrong) Up to user to use delete [] on these arrays.

int ClpSimplex::numberExtraRows | ( |  | ) | const
| inline

Number of extra rows.

These are ones which will be dynamically created each iteration. This is for GUB but may have other uses.

Definition at line 1600 of file ClpSimplex.hpp.

int ClpSimplex::maximumBasic | ( |  | ) | const
| inline

Maximum number of basic variables - can be more than number of rows if GUB.

Definition at line 1606 of file ClpSimplex.hpp.

int ClpSimplex::baseIteration | ( |  | ) | const
| inline

Iteration when we entered dual or primal.

Definition at line 1611 of file ClpSimplex.hpp.

void ClpSimplex::generateCpp | ( | FILE * | fp,
|  | bool | defaultFactor = `false`
| ) |  |

Create C++ lines to get to current state.

ClpFactorization* ClpSimplex::getEmptyFactorization | ( |  | ) |

Gets clean and emptyish factorization.

void ClpSimplex::setEmptyFactorization | ( |  | ) |

May delete or may make clean and emptyish factorization.

void ClpSimplex::moveInfo | ( | const ClpSimplex & | rhs,
|  | bool | justStatus = `false`
| ) |  |

Move status and solution across.

void ClpSimplex::getBInvARow | ( | int | row,
|  | double * | z,
|  | double * | slack = `NULL`
| ) |  |

Get a row of the tableau (slack part in slack if not NULL)

void ClpSimplex::getBInvRow | ( | int | row,
|  | double * | z
| ) |  |

Get a row of the basis inverse.

void ClpSimplex::getBInvACol | ( | int | col,
|  | double * | vec
| ) |  |

Get a column of the tableau.

void ClpSimplex::getBInvCol | ( | int | col,
|  | double * | vec
| ) |  |

Get a column of the basis inverse.

void ClpSimplex::getBasics | ( | int * | index | ) |

Get basic indices (order of indices corresponds to the order of elements in a vector retured by getBInvACol() and getBInvCol()).

void ClpSimplex::setObjectiveCoefficient | ( | int | elementIndex,
|  | double | elementValue
| ) |  |

Set an objective function coefficient.

void ClpSimplex::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue
| ) |  |
| inline

Set an objective function coefficient.

Definition at line 1654 of file ClpSimplex.hpp.

void ClpSimplex::setColumnLower | ( | int | elementIndex,
|  | double | elementValue
| ) |  |

Set a single column lower bound
Use -DBL_MAX for -infinity.

void ClpSimplex::setColumnUpper | ( | int | elementIndex,
|  | double | elementValue
| ) |  |

Set a single column upper bound
Use DBL_MAX for infinity.

void ClpSimplex::setColumnBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper
| ) |  |

Set a single column lower and upper bound.

void ClpSimplex::setColumnSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList
| ) |  |

Set the bounds on a number of columns simultaneously
The default implementation just invokes setColLower() and setColUpper() over and over again.

Parameters

  indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the variables whose either bound changes
  boundList | the new lower/upper bound pairs for the variables

void ClpSimplex::setColLower | ( | int | elementIndex,
|  | double | elementValue
| ) |  |
| inline

Set a single column lower bound
Use -DBL_MAX for -infinity.

Definition at line 1685 of file ClpSimplex.hpp.

void ClpSimplex::setColUpper | ( | int | elementIndex,
|  | double | elementValue
| ) |  |
| inline

Set a single column upper bound
Use DBL_MAX for infinity.

Definition at line 1691 of file ClpSimplex.hpp.

void ClpSimplex::setColBounds | ( | int | elementIndex,
|  | double | newlower,
|  | double | newupper
| ) |  |
| inline

Set a single column lower and upper bound.

Definition at line 1697 of file ClpSimplex.hpp.

void ClpSimplex::setColSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList
| ) |  |
| inline

Set the bounds on a number of columns simultaneously

Parameters

  indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the variables whose either bound changes
  boundList | the new lower/upper bound pairs for the variables

Definition at line 1709 of file ClpSimplex.hpp.

void ClpSimplex::setRowLower | ( | int | elementIndex,
|  | double | elementValue
| ) |  |

Set a single row lower bound
Use -DBL_MAX for -infinity.

void ClpSimplex::setRowUpper | ( | int | elementIndex,
|  | double | elementValue
| ) |  |

Set a single row upper bound
Use DBL_MAX for infinity.

void ClpSimplex::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper
| ) |  |

Set a single row lower and upper bound.

void ClpSimplex::setRowSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList
| ) |  |

Set the bounds on a number of rows simultaneously

Parameters

  indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the constraints whose either bound changes
  boundList | the new lower/upper bound pairs for the constraints

void ClpSimplex::resize | ( | int | newNumberRows,
|  | int | newNumberColumns
| ) |  |

Resizes rim part of model.

## Friends And Related Function Documentation

friend class OsiClpSolverInterface
| friend

Allow OsiClp certain perks.

Definition at line 1972 of file ClpSimplex.hpp.

friend class OsiCLPSolverInterface
| friend

And OsiCLP.

Definition at line 1974 of file ClpSimplex.hpp.

void ClpSimplexUnitTest | ( | const std::string & | mpsDir | ) |
| friend

A function that tests the methods in the ClpSimplex class.

The only reason for it not to be a member method is that this way it doesn't have to be compiled into the library. And that's a gain, because the library should be compiled with optimization on, but this method should be compiled with debugging.

It also does some testing of ClpFactorization class

## Member Data Documentation

double ClpSimplex::bestPossibleImprovement_
| protected

Best possible improvement using djs (primal) or obj change by flipping bounds to make dual feasible (dual)

Definition at line 1752 of file ClpSimplex.hpp.

double ClpSimplex::zeroTolerance_
| protected

Zero tolerance.

Definition at line 1754 of file ClpSimplex.hpp.

int ClpSimplex::columnPrimalSequence_
| protected

Sequence of worst (-1 if feasible)

Definition at line 1756 of file ClpSimplex.hpp.

int ClpSimplex::rowPrimalSequence_
| protected

Sequence of worst (-1 if feasible)

Definition at line 1758 of file ClpSimplex.hpp.

double ClpSimplex::bestObjectiveValue_
| protected

"Best" objective value

Definition at line 1760 of file ClpSimplex.hpp.

int ClpSimplex::moreSpecialOptions_
| protected

More special options - see set for details.

Definition at line 1762 of file ClpSimplex.hpp.

int ClpSimplex::baseIteration_
| protected

Iteration when we entered dual or primal.

Definition at line 1764 of file ClpSimplex.hpp.

int ClpSimplex::vectorMode_
| protected

Vector mode - try and use vector instructions.

Definition at line 1766 of file ClpSimplex.hpp.

double ClpSimplex::primalToleranceToGetOptimal_
| protected

Primal tolerance needed to make dual feasible (<largeTolerance)

Definition at line 1768 of file ClpSimplex.hpp.

double ClpSimplex::largeValue_
| protected

Large bound value (for complementarity etc)

Definition at line 1770 of file ClpSimplex.hpp.

double ClpSimplex::largestPrimalError_
| protected

Largest error on Ax-b.

Definition at line 1772 of file ClpSimplex.hpp.

double ClpSimplex::largestDualError_
| protected

Largest error on basic duals.

Definition at line 1774 of file ClpSimplex.hpp.

double ClpSimplex::alphaAccuracy_
| protected

For computing whether to re-factorize.

Definition at line 1776 of file ClpSimplex.hpp.

double ClpSimplex::dualBound_
| protected

Dual bound.

Definition at line 1778 of file ClpSimplex.hpp.

double ClpSimplex::alpha_
| protected

Alpha (pivot element)

Definition at line 1780 of file ClpSimplex.hpp.

double ClpSimplex::theta_
| protected

Theta (pivot change)

Definition at line 1782 of file ClpSimplex.hpp.

double ClpSimplex::lowerIn_
| protected

Lower Bound on In variable.

Definition at line 1784 of file ClpSimplex.hpp.

double ClpSimplex::valueIn_
| protected

Value of In variable.

Definition at line 1786 of file ClpSimplex.hpp.

double ClpSimplex::upperIn_
| protected

Upper Bound on In variable.

Definition at line 1788 of file ClpSimplex.hpp.

double ClpSimplex::dualIn_
| protected

Reduced cost of In variable.

Definition at line 1790 of file ClpSimplex.hpp.

double ClpSimplex::lowerOut_
| protected

Lower Bound on Out variable.

Definition at line 1792 of file ClpSimplex.hpp.

double ClpSimplex::valueOut_
| protected

Value of Out variable.

Definition at line 1794 of file ClpSimplex.hpp.

double ClpSimplex::upperOut_
| protected

Upper Bound on Out variable.

Definition at line 1796 of file ClpSimplex.hpp.

double ClpSimplex::dualOut_
| protected

Infeasibility (dual) or ? (primal) of Out variable.

Definition at line 1798 of file ClpSimplex.hpp.

double ClpSimplex::dualTolerance_
| protected

Current dual tolerance for algorithm.

Definition at line 1800 of file ClpSimplex.hpp.

double ClpSimplex::primalTolerance_
| protected

Current primal tolerance for algorithm.

Definition at line 1802 of file ClpSimplex.hpp.

double ClpSimplex::sumDualInfeasibilities_
| protected

Sum of dual infeasibilities.

Definition at line 1804 of file ClpSimplex.hpp.

double ClpSimplex::sumPrimalInfeasibilities_
| protected

Sum of primal infeasibilities.

Definition at line 1806 of file ClpSimplex.hpp.

double ClpSimplex::infeasibilityCost_
| protected

Weight assigned to being infeasible in primal.

Definition at line 1808 of file ClpSimplex.hpp.

double ClpSimplex::sumOfRelaxedDualInfeasibilities_
| protected

Sum of Dual infeasibilities using tolerance based on error in duals.

Definition at line 1810 of file ClpSimplex.hpp.

double ClpSimplex::sumOfRelaxedPrimalInfeasibilities_
| protected

Sum of Primal infeasibilities using tolerance based on error in primals.

Definition at line 1812 of file ClpSimplex.hpp.

double ClpSimplex::acceptablePivot_
| protected

Acceptable pivot value just after factorization.

Definition at line 1814 of file ClpSimplex.hpp.

double ClpSimplex::minimumPrimalTolerance_
| protected

Minimum primal tolerance.

Definition at line 1816 of file ClpSimplex.hpp.

double ClpSimplex::averageInfeasibility_[CLP_INFEAS_SAVE]
| protected

Definition at line 1819 of file ClpSimplex.hpp.

double* ClpSimplex::lower_
| protected

Working copy of lower bounds (Owner of arrays below)

Definition at line 1821 of file ClpSimplex.hpp.

double* ClpSimplex::rowLowerWork_
| protected

Row lower bounds - working copy.

Definition at line 1823 of file ClpSimplex.hpp.

double* ClpSimplex::columnLowerWork_
| protected

Column lower bounds - working copy.

Definition at line 1825 of file ClpSimplex.hpp.

double* ClpSimplex::upper_
| protected

Working copy of upper bounds (Owner of arrays below)

Definition at line 1827 of file ClpSimplex.hpp.

double* ClpSimplex::rowUpperWork_
| protected

Row upper bounds - working copy.

Definition at line 1829 of file ClpSimplex.hpp.

double* ClpSimplex::columnUpperWork_
| protected

Column upper bounds - working copy.

Definition at line 1831 of file ClpSimplex.hpp.

double* ClpSimplex::cost_
| protected

Working copy of objective (Owner of arrays below)

Definition at line 1833 of file ClpSimplex.hpp.

double* ClpSimplex::rowObjectiveWork_
| protected

Row objective - working copy.

Definition at line 1835 of file ClpSimplex.hpp.

double* ClpSimplex::objectiveWork_
| protected

Column objective - working copy.

Definition at line 1837 of file ClpSimplex.hpp.

CoinIndexedVector* ClpSimplex::rowArray_[6]
| protected

Useful row length arrays.

Definition at line 1839 of file ClpSimplex.hpp.

CoinIndexedVector* ClpSimplex::columnArray_[6]
| protected

Useful column length arrays.

Definition at line 1841 of file ClpSimplex.hpp.

int ClpSimplex::sequenceIn_
| protected

Sequence of In variable.

Definition at line 1843 of file ClpSimplex.hpp.

int ClpSimplex::directionIn_
| protected

Direction of In, 1 going up, -1 going down, 0 not a clue.

Definition at line 1845 of file ClpSimplex.hpp.

int ClpSimplex::sequenceOut_
| protected

Sequence of Out variable.

Definition at line 1847 of file ClpSimplex.hpp.

int ClpSimplex::directionOut_
| protected

Direction of Out, 1 to upper bound, -1 to lower bound, 0 - superbasic.

Definition at line 1849 of file ClpSimplex.hpp.

int ClpSimplex::pivotRow_
| protected

Pivot Row.

Definition at line 1851 of file ClpSimplex.hpp.

int ClpSimplex::lastGoodIteration_
| protected

Last good iteration (immediately after a re-factorization)

Definition at line 1853 of file ClpSimplex.hpp.

double* ClpSimplex::dj_
| protected

Working copy of reduced costs (Owner of arrays below)

Definition at line 1855 of file ClpSimplex.hpp.

double* ClpSimplex::rowReducedCost_
| protected

Reduced costs of slacks not same as duals (or - duals)

Definition at line 1857 of file ClpSimplex.hpp.

double* ClpSimplex::reducedCostWork_
| protected

Possible scaled reduced costs.

Definition at line 1859 of file ClpSimplex.hpp.

double* ClpSimplex::solution_
| protected

Working copy of primal solution (Owner of arrays below)

Definition at line 1861 of file ClpSimplex.hpp.

double* ClpSimplex::rowActivityWork_
| protected

Row activities - working copy.

Definition at line 1863 of file ClpSimplex.hpp.

double* ClpSimplex::columnActivityWork_
| protected

Column activities - working copy.

Definition at line 1865 of file ClpSimplex.hpp.

int ClpSimplex::numberDualInfeasibilities_
| protected

Number of dual infeasibilities.

Definition at line 1867 of file ClpSimplex.hpp.

int ClpSimplex::numberDualInfeasibilitiesWithoutFree_
| protected

Number of dual infeasibilities (without free)

Definition at line 1869 of file ClpSimplex.hpp.

int ClpSimplex::numberPrimalInfeasibilities_
| protected

Number of primal infeasibilities.

Definition at line 1871 of file ClpSimplex.hpp.

int ClpSimplex::numberRefinements_
| protected

How many iterative refinements to do.

Definition at line 1873 of file ClpSimplex.hpp.

ClpDualRowPivot* ClpSimplex::dualRowPivot_
| protected

dual row pivot choice

Definition at line 1875 of file ClpSimplex.hpp.

ClpPrimalColumnPivot* ClpSimplex::primalColumnPivot_
| protected

primal column pivot choice

Definition at line 1877 of file ClpSimplex.hpp.

int* ClpSimplex::pivotVariable_
| protected

Basic variables pivoting on which rows.

Definition at line 1879 of file ClpSimplex.hpp.

ClpFactorization* ClpSimplex::factorization_
| protected

factorization

Definition at line 1881 of file ClpSimplex.hpp.

double* ClpSimplex::savedSolution_
| protected

Saved version of solution.

Definition at line 1883 of file ClpSimplex.hpp.

int ClpSimplex::numberTimesOptimal_
| protected

Number of times code has tentatively thought optimal.

Definition at line 1885 of file ClpSimplex.hpp.

ClpDisasterHandler* ClpSimplex::disasterArea_
| protected

Disaster handler.

Definition at line 1887 of file ClpSimplex.hpp.

int ClpSimplex::changeMade_
| protected

If change has been made (first attempt at stopping looping)

Definition at line 1889 of file ClpSimplex.hpp.

int ClpSimplex::algorithm_
| protected

Algorithm >0 == Primal, <0 == Dual.

Definition at line 1891 of file ClpSimplex.hpp.

int ClpSimplex::forceFactorization_
| protected

Now for some reliability aids This forces re-factorization early.

Definition at line 1894 of file ClpSimplex.hpp.

int ClpSimplex::perturbation_
| protected

Perturbation: -50 to +50 - perturb by this power of ten (-6 sounds good) 100 - auto perturb if takes too long (1.0e-6 largest nonzero) 101 - we are perturbed 102 - don't try perturbing again default is 100.

Definition at line 1902 of file ClpSimplex.hpp.

unsigned char* ClpSimplex::saveStatus_
| protected

Saved status regions.

Definition at line 1904 of file ClpSimplex.hpp.

ClpNonLinearCost* ClpSimplex::nonLinearCost_
| protected

Very wasteful way of dealing with infeasibilities in primal.

However it will allow non-linearities and use of dual analysis. If it doesn't work it can easily be replaced.

Definition at line 1909 of file ClpSimplex.hpp.

int ClpSimplex::lastBadIteration_
| protected

So we know when to be cautious.

Definition at line 1911 of file ClpSimplex.hpp.

int ClpSimplex::lastFlaggedIteration_
| protected

So we know when to open up again.

Definition at line 1913 of file ClpSimplex.hpp.

int ClpSimplex::numberFake_
| protected

Can be used for count of fake bounds (dual) or fake costs (primal)

Definition at line 1915 of file ClpSimplex.hpp.

int ClpSimplex::numberChanged_
| protected

Can be used for count of changed costs (dual) or changed bounds (primal)

Definition at line 1917 of file ClpSimplex.hpp.

int ClpSimplex::progressFlag_
| protected

Progress flag - at present 0 bit says artificials out, 1 free in.

Definition at line 1919 of file ClpSimplex.hpp.

int ClpSimplex::firstFree_
| protected

First free/super-basic variable (-1 if none)

Definition at line 1921 of file ClpSimplex.hpp.

int ClpSimplex::numberExtraRows_
| protected

Number of extra rows.

These are ones which will be dynamically created each iteration. This is for GUB but may have other uses.

Definition at line 1925 of file ClpSimplex.hpp.

int ClpSimplex::maximumBasic_
| protected

Maximum number of basic variables - can be more than number of rows if GUB.

Definition at line 1928 of file ClpSimplex.hpp.

int ClpSimplex::dontFactorizePivots_
| protected

If may skip final factorize then allow up to this pivots (default 20)

Definition at line 1930 of file ClpSimplex.hpp.

double ClpSimplex::incomingInfeasibility_
| protected

For advanced use.

When doing iterative solves things can get nasty so on values pass if incoming solution has largest infeasibility < incomingInfeasibility throw out variables from basis until largest infeasibility < allowedInfeasibility. if allowedInfeasibility>= incomingInfeasibility this is always possible altough you may end up with an all slack basis.

Defaults are 1.0,10.0

Definition at line 1940 of file ClpSimplex.hpp.

double ClpSimplex::allowedInfeasibility_
| protected

Definition at line 1941 of file ClpSimplex.hpp.

int ClpSimplex::automaticScale_
| protected

Automatic scaling of objective and rhs and bounds.

Definition at line 1943 of file ClpSimplex.hpp.

int ClpSimplex::maximumPerturbationSize_
| protected

Maximum perturbation array size (take out when code rewritten)

Definition at line 1945 of file ClpSimplex.hpp.

double* ClpSimplex::perturbationArray_
| protected

Perturbation array (maximumPerturbationSize_)

Definition at line 1947 of file ClpSimplex.hpp.

ClpSimplex* ClpSimplex::baseModel_
| protected

A copy of model with certain state - normally without cuts.

Definition at line 1949 of file ClpSimplex.hpp.

ClpSimplexProgress ClpSimplex::progress_
| protected

For dealing with all issues of cycling etc.

Definition at line 1951 of file ClpSimplex.hpp.

int ClpSimplex::numberDegeneratePivots_
| protected

Number of degenerate pivots since last perturbed.

Definition at line 1962 of file ClpSimplex.hpp.

int ClpSimplex::spareIntArray_[4]
| mutable

Spare int array for passing information [0]!=0 switches on.

Definition at line 1966 of file ClpSimplex.hpp.

double ClpSimplex::spareDoubleArray_[4]
| mutable

Spare double array for passing information [0]!=0 switches on.

Definition at line 1968 of file ClpSimplex.hpp.

The documentation for this class was generated from the following file:

- /tmp/Cgl-0.60.2/Clp/src/ClpSimplex.hpp